{****  Bezier 1.0 Doug Overmyer ********}
program Bez;
{$R BEZ.RES}
uses WinTypes, WinProcs, WObjects,Strings,Icons;
const
  BZ_Name =  'Bzier Demo';
  idm_BZChange = 301;
  idm_BZShowHide=302;
  um_ReSize    = 401;
  id_IG1   =      600;
  id_Icon1 =      601;
  id_Icon2 =      602;
  id_Icon3 =      603;
  id_Icon4 =      604;
  id_Icon5 =      605;
  id_Icon6 =      606;
  id_Icon7 =      607;
  id_Icon8 =      608;
  bs_Custom =      99;
  IWidth     =     32;
  BEZ_DEPTH  =      5;
  NUM_BEZPTS =     33;
  st_NotStart = 0;
  st_DragHand1  = 1;
  st_WaitCtrl2  = 2;
  st_DragHand2  = 3;
  md_DrawBezier = 1;
{**********************  TYPES      ******************************}
type
  TBZApp = object(TApplication)
  procedure InitMainWindow; virtual;
end;

PBezPoint = ^TBezPoint;
TBezPoint = object(TObject)
	C1,H1,H2,C2:TPoint;
  constructor Init(NewC1,NewH1,NewH2,NewC2:TPoint);
end;

PBZToolbar = ^TBZToolbar;
TBZToolbar = object(TWindow)
	Icon:Array[0..8] of PIcon;
  IG1:PIconGroup;
  Orientation:Integer;
  constructor Init(AParent:PWindowsObject;ATitle:PChar);
  destructor Done;virtual;
  procedure WMDrawItem(var Msg:TMessage);virtual wm_First+wm_DrawItem;
  procedure UMReSize(var Msg: TMessage); virtual wm_User + um_ReSize;
  procedure WMCommand(Var Msg:TMessage);virtual wm_First+wm_Command;
  procedure WMNCLButtonDblClk(var Msg:TMessage);virtual wm_First+
  	wm_NCLButtonDblClk;
  procedure ToggleOrientation;
end;

PBezTool = ^TBezTool;
TBezTool = object
	DC:HDc;
  InPt:TPoint;
  LDFact:Integer;
  State:Integer;
	Ctrl1,Hand1,Hand2,Ctrl2:TPoint;
  BezPts:Array[0..NUM_BEZPTS] of TPoint;
	BezPtsIndx:Integer;
	constructor Init;
  destructor Done;virtual;
  procedure SetMode(HWin:HWnd; Msg:TMessage);
  procedure WMLButtonDown(HWin:Hwnd;var Msg:TMessage);virtual;
  procedure WMRButtonDown(HWin:HWnd;var Msg:TMessage);virtual;
  procedure WMMouseMove(HWin:HWnd;var Msg:TMessage);virtual;
  procedure WMLButtonUp(HWin:HWnd;var Msg:TMessage);virtual;
  procedure DrawBez(TheDC:HDC;C1,H1,H2,C2:TPoint);virtual;
  procedure SubDivideBez(p0,p1,p2,p3:TPoint;BezDepth:Integer);virtual;
  procedure DrawHandle(TheDC:HDc;p,q:TPoint);virtual;
end;


PBZWindow = ^TBZWindow;
TBZWindow = object(TWindow)
	ToolBar:PBZToolbar;
  BezTool:PBezTool;
  lbColor:TColorRef;
  ColorIndx:Integer;
  RedPen,BezPen:HPen;
  Picture:PCollection;
  Mode:Integer;
  Cross,Arrow:HCursor;
  constructor Init(ATitle: PChar);
  destructor Done; virtual;
  procedure SetupWindow;virtual;
	procedure WMSize(var Msg: TMessage); virtual wm_First + wm_Size;
	procedure IDIcon1(Var Msg:TMessage);virtual wm_User+id_Icon1;
	procedure IDIcon2(Var Msg:TMessage);virtual wm_User+id_Icon2;
	procedure IDIcon3(Var Msg:TMessage);virtual wm_User+id_Icon3;
	procedure IDIcon4(Var Msg:TMessage);virtual wm_User+id_Icon4;
  procedure WMLButtonDown(var Msg:TMessage);virtual wm_First+wm_LButtonDown;
  procedure WMRButtonDown(var Msg:TMessage);virtual wm_First+wm_rButtonDown;
  procedure WMMouseMove(var Msg:TMessage);virtual wm_First+wm_MouseMove;
  procedure WMLButtonUp(var Msg:TMessage);virtual wm_First+wm_LButtonUp;
  procedure Paint(PaintDC:HDC;var PaintInfo:TPaintStruct);virtual;
  procedure DrawCoords(ADC:HDC);
end;
{**********************  GLOBALS   ******************************}
var
	MainWin:PBZWindow;

function Tenary(Exp:Boolean;T,F:LongInt):LongInt;
begin
	if Exp then Tenary := T else Tenary := F;
end;
{**********************  METHODS    ******************************}
procedure TBZApp.InitMainWindow;
begin
  MainWindow := New(PBZWindow, Init(BZ_Name));
  MainWin := PBZWindow(MainWindow);
end;
{**********************  TBZWindow  *******************************}
constructor TBZWindow.Init(ATitle: PChar);
begin
  TWindow.Init(nil, ATitle);
  with Attr do
  	begin
    X := 50; Y := 50; W := 500; H := 300;
  	end;
	ToolBar := New(PBZToolbar,Init(@Self,'Tools'));
  BezTool := New(PBezTool,Init);
  lbColor := RGB(0,0,0);
  ColorIndx := 0;
  RedPen := CreatePen(ps_Solid,1,RGB(255,0,0));
  BezPen := CreatePen(ps_Solid,1,RGB(0,0,0));
	Picture := New(PCollection,Init(10,10));
  Mode := 0;
end;

destructor TBZWindow.Done;
var
	Msg:TMessage;
begin
  TWindow.Done;
  Dispose(BezTool,Done);
  if BezPen <> 0 then
  	DeleteObject(BezPen);
  DeleteObject(RedPen);
  Dispose(Picture,Done);
end;

procedure TBZWindow.SetupWindow;
var
	SysMenu:HMenu;
begin
	TWindow.SetupWindow;
	SetClassWord(HWindow,GCW_HIcon,LoadIcon(HInstance,'BZ_Icon'));
  if ToolBar <> nil then
		SendMessage(ToolBar^.HWindow,wm_User+um_ReSize,0,0);
  Cross := LoadCursor(0,idc_Cross);
  Arrow := LoadCursor(0,idc_Arrow);
end;

procedure TBZWindow.WMSize(var Msg: TMessage);
begin
  TWindow.WMSize(Msg);
  if ToolBar <> nil then    {optional follow-along}
		SendMessage(ToolBar^.HWindow,wm_User+um_ReSize,0,0);
end;

procedure TBZWindow.IDIcon1(var Msg:TMessage);
begin
	Mode := md_DrawBezier;
  Cross := LoadCursor(0,idc_Cross);
  SetClassWord(HWindow,gcw_HCursor,Cross);
end;

procedure TBZWindow.IDIcon2(var Msg:TMessage);
var
	C:TPoint;
begin
	Mode := 0;
  SetClassWord(HWindow,gcw_HCursor,Arrow);
	Picture^.FreeAll;
  C.X := 0; C.Y := 0;
	InvalidateRect(HWindow,nil,True);
end;

procedure TBZWindow.IDIcon3(var Msg:TMessage);
begin
	Mode := 0;
  SetClassWord(HWindow,gcw_HCursor,Arrow);
	Inc(ColorIndx);
  If ColorIndx > 9 then ColorIndx := 0;
	case ColorIndx of
  	0:lbColor := RGB(0,0,0);
  	1:lbColor := RGB(0,0,255);
  	2:lbColor := RGB(255,0,0);
  	3:lbColor := RGB(255,0,255);
  	4:lbColor := RGB(0,255,0);
  	5:lbColor := RGB(0,255,255);
  	6:lbColor := RGB(255,255,0);
  	7:lbColor := RGB(255,255,255);
  	8:lbColor := RGB(192,192,192);
  	9:lbColor := RGB(128,128,128);
  end;
  if BezPen <> 0 then
  	DeleteObject(BezPen);
  BezPen := CreatePen(ps_Solid,1,lbColor);
end;

procedure TBZWindow.IDIcon4(var Msg:TMessage);
begin
	CloseWindow;
end;

procedure TBZWindow.WMLButtonDown(var Msg:TMessage);
begin
	Case Mode of
	md_DrawBezier:BezTool^.WMLButtonDown(HWindow,Msg);
  end;
end;

procedure TBZWindow.WMRButtonDown(var Msg:TMessage);
begin
	Picture^.FreeAll;
	InvalidateRect(HWindow,nil,True);
end;

procedure TBZWindow.WMMouseMove(var Msg:TMessage);
begin
	case Mode of
  	md_DrawBezier:	BezTool^.WMMouseMove(HWindow,Msg);
	end;
end;
procedure TBZWindow.WMLButtonUp(var Msg:TMessage);
var
	ADC:HDC;
begin
	case Mode of
  	md_DrawBezier:
    	begin
      BezTool^.WMLButtonUp(HWindow,Msg);
			ADC := GetDC(HWindow);
      DrawCoords(ADC);
  		ReleaseDC(HWindow,ADC);
      end;
  end;
end;

procedure TBZWindow.Paint(PaintDC:HDC;var PaintInfo:TPaintStruct);
var
  Indx:Integer;
  BP:PBezPoint;
begin
  DrawCoords(PaintDC);
  SetMapMode(PaintDC,mm_Twips);
  if Picture^.Count > 0 then
    for Indx := 0 to (Picture^.Count -1) do
    	begin
      BP := Picture^.At(Indx);
			BezTool^.DrawBez(PaintDC,BP^.C1,BP^.H1,BP^.H2,BP^.C2);
      end;
end;

procedure TBZWindow.DrawCoords(ADC:HDC);
var
	BezPts : Record
  	C1X,C1Y,H1X,H1Y,C2X,C2Y,H2X,H2Y:Integer;
  end;
  OutStr:Array[0..255] of Char;
  Indx:Integer;
  BP:PBezPoint;
begin
	StrCopy(OutStr,'');
  FillChar(OutStr,250,' ');
  TextOut(ADC,5,5,OutStr,StrLen(OutStr));
  if Picture^.Count > 0 then
  	begin
  	BP := Picture^.At(Picture^.Count-1);
  	BezPts.C1X := BP^.C1.x;
  	BezPts.C1Y := BP^.C1.Y;
  	BezPts.H1X := BP^.H1.x;
  	BezPts.H1y := BP^.H1.y;
  	BezPts.C2X := BP^.C2.x;
  	BezPts.C2y := BP^.C2.y;
  	BezPts.H2X := BP^.H2.x;
  	BezPts.H2y := BP^.H2.y;
    end
  else
		begin
  	BezPts.C1X := 0;
  	BezPts.C1Y := 0;
  	BezPts.H1X := 0;
  	BezPts.H1y := 0;
  	BezPts.C2X := 0;
  	BezPts.C2y := 0;
  	BezPts.H2X := 0;
  	BezPts.H2y := 0;
    end;

	wvsprintf(OutStr,'C1(%i,%i) H1(%i,%i) C2(%i,%i) H2(%i,%i)',BezPts);
	TextOut(ADC,5,5,OutStr,StrLen(OutStr));
end;

{**********************   TBezTool    *****************************}
constructor TBezTool.Init;
begin
	DC := 0;
  State := 0;
	Ctrl1.x := 0;Ctrl1.y := 0;Hand1.x :=0;Hand1.Y := 0;
	Ctrl2.x := 0;Ctrl2.y := 0;Hand2.x :=0;Hand2.Y := 0;
end;

destructor TBezTool.Done;
begin
end;

procedure TBezTool.SetMode(HWin:HWnd; Msg:TMessage);
var
	CR:TRect;
  cxClient,cyClient:Word;
  MaxClient:Word;
  Pts:Array[0..1] of TPoint;
begin
	if DC = 0 then
		DC := GetDC(HWin);
  GetClientRect(HWin,CR);
  cxClient := CR.Right-CR.Left;
  cyClient := CR.Bottom-CR.Top;
  MaxClient := Tenary(cxClient >cyClient,cxClient,cyClient);
  SetMapMode(DC,mm_Twips);
  Pts[0].x := 0; Pts[0].y := 0; Pts[1].x := 1; Pts[1].y := 1;
  DPtoLP(DC,Pts,2);
  LDFact := Pts[1].x - pts[0].x ;
  if LDFact < 0 then LDFact := -(LDFact);
  InPt.x := Msg.LparamLo;
  InPt.y := Msg.LparamHi;
  DPtoLP(DC,InPt,1);
end;

procedure TBezTool.WMLButtonDown(HWin:HWnd;var Msg:TMessage);
begin
	SetMode(HWin,Msg);
	case State of
  	st_NotStart:
    	begin
      State := st_DragHand1;
      Hand1.x := InPt.x; Ctrl1.x := InPt.x;
      Hand1.y := InPt.y; Ctrl1.y := InPt.y;
      end;
  	st_WaitCtrl2:
    	begin
      State := st_DragHand2;
      Hand2.x := InPt.x; Ctrl2.x := InPt.x;
      Hand2.y := InPt.y; Ctrl2.y := InPt.y;
      SetROP2(DC,R2_NotXORPen);
      DrawBez(DC,ctrl1,hand1,hand2,ctrl2);
      end;
  end;
  ReleaseDC(HWin,DC);
  DC := 0;
end;

procedure TBezTool.WMRButtonDown(HWin:HWnd;var Msg:TMessage);
var
	C:TPoint;
begin
	MainWin^.Picture^.FreeAll;
  C.X := 0; C.Y := 0;
  Ctrl1 := C;Hand1 := C;Hand2 := C;Ctrl2 := C;
	InvalidateRect(HWin,nil,True);
end;

procedure TBezTool.WMMouseMove(HWin:HWnd;var Msg:TMessage);
begin
	if State = st_NotStart then
  	Exit;
	SetMode(HWin,Msg);
	case State of
  	st_DragHand1:
    	begin
      SetROP2(DC,R2_NotXORPen);
			DrawHandle(DC,ctrl1,hand1);
      Hand1.x := InPt.x;
      Hand1.y := InPt.y;
			DrawHandle(DC,ctrl1,hand1);
      end;
  	st_DragHand2:
    	begin
      SetROP2(DC,R2_NotXORPen);
			DrawHandle(DC,ctrl2,hand2);
      DrawBez(DC,ctrl1,hand1,hand2,ctrl2);
      Hand2.x := InPt.x;
      Hand2.y := InPt.y;
 			DrawHandle(DC,ctrl2,hand2);
      DrawBez(DC,ctrl1,hand1,hand2,ctrl2);
      end;
  end;
  ReleaseDC(HWin,DC);
  DC := 0;
end;

procedure TBezTool.WMLButtonUp(HWin:HWnd;var Msg:TMessage);
begin
	SetMode(HWin,Msg);
	case State of
  	st_DragHand1:
    	begin
      State := st_WaitCtrl2;
      SetROP2(DC,R2_CopyPen);
			DrawHandle(DC,ctrl1,hand1);
      end;
  	st_DragHand2:
    	begin
      State := st_NotStart;
      SetROP2(DC,R2_CopyPen);
			DrawHandle(DC,ctrl2,hand2);
      DrawBez(DC,ctrl1,hand1,hand2,ctrl2);
      MainWin^.Picture^.Insert(New(PBezPoint,Init(Ctrl1,Hand1,Hand2,Ctrl2)));
      end;
  end;
  ReleaseDC(HWin,DC);
  DC := 0;
end;

procedure TBezTool.DrawBez(TheDC:HDC;C1,H1,H2,C2:TPoint);
var
	OldPen:HPen;
begin
  BezPtsIndx := 0;
  BezPts[BezPtsIndx] := C1;
	Inc(BezPtsIndx) ;
  SubDivideBez(C1,H1,H2,C2,BEZ_DEPTH);
  OldPen := SelectObject(TheDC,MainWin^.BezPen);
  Polyline(TheDC,BezPts,NUM_BEZPTS);
  SelectObject(TheDC,OldPen);
end;

procedure TBezTool.SubDivideBez(p0,p1,p2,p3:TPoint;BezDepth:Integer);
var
	q0,q1,q2,r0,r1,s0:TPoint;
begin
	if (BezDepth=0) then
  	begin
  	BezPts[BezPtsIndx] := p3;
    inc(BezPtsIndx);
    exit;
    end;
  q0.x := ((p0.x + p1.x) div 2); q0.y := ((p0.y + p1.y) div 2);
  q1.x := ((p1.x + p2.x) div 2); q1.y := ((p1.y + p2.y) div 2);
  q2.x := ((p2.x + p3.x) div 2); q2.y := ((p2.y + p3.y) div 2);
  r0.x := ((q0.x + q1.x) div 2); r0.y := ((q0.y + q1.y) div 2);
  r1.x := ((q1.x + q2.x) div 2); r1.y := ((q1.y + q2.y) div 2);
  s0.x := ((r0.x + r1.x) div 2); s0.y := ((r0.y + r1.y) div 2);
  Dec(BezDepth);
  SubDivideBez(p0,q0,r0,s0,BezDepth);
  SubDivideBez(s0,r1,q2,p3,BezDepth);
end;

procedure TBezTool.DrawHandle(TheDC:Hdc;p,q:TPoint);
var
	OldPen:HPen;
  xLeft,xRight,yTop,yBottom:Integer;
begin
	OldPen := SelectObject(DC,MainWin^.RedPen);
  MoveTo(TheDC,p.x,p.y);
  LineTo(TheDC,q.x,q.y);
  xLeft := q.x - LDFact;
  xRight := q.x + (LDFact);
  yTop := q.y + LDFact;
  yBottom := q.y - LDFact;
  Rectangle(TheDC,xLeft,yTop,XRight,yBottom);
  SelectObject(TheDC,OldPen);
end;

{***********************  TBZToolbar   ****************************}
constructor TBZToolbar.Init(AParent:PWindowsObject;ATitle:PChar);
Const
	BMP:Array[0..8] of PChar = ('','TB_Tool1','TB_Tool2','TB_Tool3','TB_Tool4',
  'TB_Tool5',  'TB_Tool6','TB_Tool7','TB_Tool8');
var
	Indx:Integer;
  Buf:Array[0..8] of Char;
begin
	TWindow.Init(AParent,Atitle);
  Attr.Style :=  ws_PopUpWindow or ws_Visible or ws_Caption;
  Orientation := 0;
  For Indx := 0 to 8 do Icon[Indx] := nil;
  IG1 := New(PIconGroup,Init(@Self,id_IG1,'',0,0,IWidth*4,IWidth*2));
  For Indx := 1 to 8 do
		Icon[Indx] := New(PIcon,Init(@Self,Indx+600,'',0,0,IWidth,IWidth,IG1,BMP[Indx]));
end;

destructor TBZToolbar.Done;
begin
 	TWindow.Done;
  MainWin^.ToolBar := nil;
end;

procedure TBZToolbar.UMReSize(var Msg:TMessage);
var
  CR:TRect;
  aPt:TPoint;
  Indx:Integer;
begin
  GetClientRect(Parent^.HWindow,CR);
  aPt.X := CR.Right;aPt.Y := CR.Top;
  ClientToScreen(Parent^.HWindow,aPt);
  if Orientation = 0 then
  	begin
  	SetWindowPos(HWindow,0,aPt.X-129,aPt.Y,129,
    		GetSystemMetrics(sm_CYSize)+67,swp_NoZOrder);
  	for Indx := 1  to 4 do
    	MoveWindow(Icon[Indx]^.HWindow,IWidth*(Indx-1),0,IWidth,IWidth,False);
  	for Indx := 5  to 8 do
    	MoveWindow(Icon[Indx]^.HWindow,IWidth*(Indx-5),IWidth,IWidth,IWidth,False);
    MoveWindow(IG1^.HWindow,0,0,IWidth*(4),IWidth*2,True);
  	end
  else
  	begin
  	SetWindowPos(HWindow,0,aPt.X-66,aPt.Y,66,
    		GetSystemMetrics(sm_CYSize)+129,swp_NoZOrder);
  	for Indx := 1  to 2 do
    	MoveWindow(Icon[Indx]^.HWindow,IWidth*(Indx-1),0,IWidth,IWidth,False);
  	for Indx := 3  to 4 do
    	MoveWindow(Icon[Indx]^.HWindow,IWidth*(Indx-3),IWidth,IWidth,IWidth,False);
  	for Indx := 5  to 6 do
    	MoveWindow(Icon[Indx]^.HWindow,IWidth*(Indx-5),IWidth*2,IWidth,IWidth,False);
  	for Indx := 7  to 8 do
    	MoveWindow(Icon[Indx]^.HWindow,IWidth*(Indx-7),IWidth*3,IWidth,IWidth,False);
    MoveWindow(IG1^.HWindow,0,0,IWidth*2,IWidth*4,True);
    end;
  SetFocus(Parent^.HWindow);
end;

procedure TBZToolbar.WMDrawItem(var Msg:TMessage);
var
	PDIS : ^TDrawItemStruct;
begin
	PDIS := Pointer(Msg.lParam);
	case PDIS^.CtlType of
		odt_Button:
		case PDIS^.CtlID of
			id_Icon1..id_Icon8:Icon[PDIS^.CtlID-600]^.DrawItem(Msg);
		end;
	end;
end;

procedure TBZToolbar.WMCommand(var Msg:TMessage);
begin
	TWindow.WMCommand(Msg);
	case Msg.WParam of
    id_Icon1..id_Icon8:SendMessage(Parent^.HWindow,
    		wm_User+Msg.Wparam,0,0);
 	end;
end;

procedure TBZToolbar.WMNCLButtonDblClk(var Msg:TMessage);
begin
  ToggleOrientation;
	SendMessage(HWindow,wm_User+um_ReSize,0,0);
end;

procedure TBZToolbar.ToggleOrientation;
begin
  Orientation := Tenary(Orientation = 1,0,1);
end;
{***********************TBezPoint ********************************}
constructor TBezPoint.Init(NewC1,NewH1,NewH2,NewC2:TPoint);
begin
	C1 := NewC1;
  H1 := NewH1;
  H2 := NewH2;
  C2 := NewC2;
end;
{**********************  MainLine   *******************************}
var
  BZApp: TBZApp;
begin
  BZApp.Init(BZ_Name);
  BZApp.Run;
  BZApp.Done;
end.
