(* Translated from DDLBOX.ZIP located in Borland C++/Win Forum *)
(* Original translator did not leave his name                  *)

{ Brad Stowers                                        12/17/93
  Compuserve ID: 72733, 3374

  Updated TDragListBox to lose some of it's C++ flavor and become more BPish
  Added TMultiDragListBox to allow for dragging multiple selections and the
        TIntArray and TMultiDropStruct types needed to accomplish this.       }

unit DList;

INTERFACE

uses
  WinProcs, WinTypes, OWindows, ODialogs;

const
  dm_Drop = wm_User + 99;
  dl_CanDrop = 99;

type
  PIntArray = ^TIntArray;
  TIntArray = array [1..16384] of Integer;  { I hope you never need to drag this many }

  PDropStruct = ^TDropStruct;
  TDropStruct = record
    hSource   : hWnd;
    hDest     : hWnd;
    ItemIndex : integer;
  end;

  PMultiDropStruct = ^TMultiDropStruct;
  TMultiDropStruct = record
    hSource   : hWnd;
    hDest     : hWnd;
    NumItems  : integer;
    ItemArray : PIntArray;
  end;

  PDragListBox = ^TDragListBox;
  TDragListBox = object(TListBox)
    hDrop, hNoDrop : HCursor;
    CurWnd         : HWnd;
    DMQueryReceive : word;
    CaptureSet, InsideSource, CanAccept: boolean;

    constructor Init(AParent: PWindowsObject; AnId: Integer; X,Y,W,H: Integer;
                     hD, hND: HCursor);
    constructor InitResource(AParent: PWindowsObject; AnId: integer;
                             hD, hND: HCursor);
    procedure WMLButtonDown(var Msg : TMessage);
      virtual wm_First + wm_LButtonDown;
    procedure WMLButtonUp(var Msg : TMessage);
      virtual wm_First + wm_LButtonUp;
    procedure WMMouseMove(var Msg : TMessage);
      virtual wm_First + wm_MouseMove;
    procedure DefWndProc(var Msg : TMessage); virtual;
  end;

  PMultiDragListBox = ^TMultiDragListBox;
  TMultiDragListBox = object(TDragListBox)
    hMultiDrop: hCursor;

    constructor Init(AParent: PWindowsObject; AnId: Integer; X,Y,W,H: Integer;
                     hD, hND, hMD: HCursor);
    constructor InitResource(AParent: PWindowsObject; AnId: integer;
                             hD, hND, hMD: HCursor);
    procedure WMLButtonUp(var Msg : TMessage);
      virtual wm_First + wm_LButtonUp;
    procedure WMMouseMove(var Msg : TMessage);
      virtual wm_First + wm_MouseMove;
  end;

IMPLEMENTATION

constructor TDragListBox.Init(AParent: PWindowsObject; AnId: Integer;
                              X,Y,W,H: Integer; hD, hND: HCursor);
begin
  inherited Init(AParent, AnId, X, Y, W, H);
  DMQueryReceive:=RegisterWindowMessage('DMQueryReceive');
  CaptureSet := False;
  InsideSource := True;
  CanAccept := False;
  hDrop := hD;
  hNoDrop := hND;
end;

constructor TDragListBox.InitResource(AParent: PWindowsObject; AnId : integer;
                                      hD, hND: HCursor);
begin
  inherited InitResource(AParent, AnId);
  DMQueryReceive:=RegisterWindowMessage('DMQueryReceive');
  CaptureSet := False;
  InsideSource := True;
  CanAccept := False;
  hDrop := hD;
  hNoDrop := hND;
end;

procedure TDragListBox.WMLButtonDown(var Msg : TMessage);
begin
  CaptureSet := True;
  SetCapture(hWindow);
  if (InsideSource) then
    DefWndProc(Msg);
end;

procedure TDragListBox.WMLButtonUp(var Msg : TMessage);
var
  DS : TDropStruct;
begin
  if (CaptureSet) then begin (* Was button down? *)
    ReleaseCapture;
    CaptureSet := False;
    if (CanAccept) and (hWindow <> CurWnd) then begin (* We have dragged a selection! *)
      DS.hSource := hWindow;
      DS.hDest:= CurWnd;
      DS.ItemIndex := GetSelIndex;
      SendMessage(Parent^.hWindow, dm_Drop, 0, LongInt(@DS));
    end;
    CanAccept := False;
  end;
  DefWndProc(Msg);
end;

procedure TDragListBox.WMMouseMove(var Msg : TMessage);
var
  P : TPoint;
  DropFlag : integer;
begin
  P := MakePoint(Msg.lParam);
  ClientToScreen(hWindow, P);
  CurWnd := WindowFromPoint(P);
  InsideSource := (CurWnd = HWindow);
  if (InsideSource) then begin
    SetCursor(GetClassWord(HWindow, GCW_HCURSOR));
    DefWndProc(Msg);
  end else begin
    if (GetSelIndex < 0) then
      CanAccept := False
    else begin
      DropFlag := 0;
      SendMessage(CurWnd, DMQueryReceive, 0, LongInt(@DropFlag));
      CanAccept := (DropFlag and dl_CanDrop) = dl_CanDrop;
    end;
    if CanAccept then
      SetCursor(hdrop)
    else
      SetCursor(hNoDrop);
  end;
end;

procedure TDragListBox.DefWndProc(var Msg : TMessage);
begin
  if (Msg.Message = DMQueryReceive) then
    Integer(Pointer(Msg.LParam)^) := dl_CanDrop
  else
    inherited DefWndProc(Msg);
end;



constructor TMultiDragListBox.Init(AParent: PWindowsObject; AnId: integer;
                                   X,Y,W,H: integer; hD,hND,hMD: HCursor);
begin
  inherited Init(AParent, AnId, X, Y, W, H, hD, hND);
  hMultiDrop := hMD;
end;

constructor TMultiDragListBox.InitResource(AParent: PWindowsObject; AnId: integer;
                                           hD,hND,hMD : HCursor);
begin
  inherited InitResource(AParent, AnId, hD, hND);
  hMultiDrop := hMD;
end;

procedure TMultiDragListBox.WMLButtonUp(var Msg : TMessage);
var
  DS : TMultiDropStruct;
begin
  if (CaptureSet) then begin (* Was button down? *)
    ReleaseCapture;
    CaptureSet := False;
    if (CanAccept) and (hWindow <> CurWnd) then begin (* We have dragged a selection! *)
      DS.hSource := hWindow;
      DS.hDest:= CurWnd;
      DS.NumItems := SendMessage(hWindow, lb_GetSelCount, 0, 0);
      GetMem(DS.ItemArray, DS.NumItems * SizeOf(Integer));
      SendMessage(hWindow, lb_GetSelItems, DS.NumItems, LongInt(DS.ItemArray));
      SendMessage(Parent^.hWindow, dm_Drop, 0, LongInt(@DS));
      FreeMem(DS.ItemArray, DS.NumItems * SizeOf(Integer));
    end;
    CanAccept := False;
  end;
  DefWndProc(Msg);
end;

procedure TMultiDragListBox.WMMouseMove(var Msg : TMessage);
var
  P : TPoint;
  NumSelected,
  DropFlag : integer;
begin
  P := MakePoint(Msg.lParam);
  ClientToScreen(hWindow, P);
  CurWnd := WindowFromPoint(P);
  InsideSource := (CurWnd = HWindow);
  if (InsideSource) then begin
    SetCursor(GetClassWord(HWindow, GCW_HCURSOR));
    DefWndProc(Msg);
  end else begin
    NumSelected := SendMessage(hWindow, lb_GetSelCount, 0, 0);
    if (NumSelected < 0) then
      CanAccept := False
    else begin
      DropFlag := 0;
      SendMessage(CurWnd, DMQueryReceive, 0, LongInt(@DropFlag));
      CanAccept := (DropFlag and dl_CanDrop) = dl_CanDrop;
    end;
    if CanAccept then
      if NumSelected > 1 then
        SetCursor(hMultiDrop)
      else
        SetCursor(hdrop)
    else
      SetCursor(hNoDrop);
  end;
end;

end.
