(*****************************************************************)
(*                                                               *)
(*     Microworks ObjectMate                                     *)
(*                                                               *)
(*     Version 2.52                                              *)
(*                                                               *)
(*     An ObjectWindows 1.0 extension for Borland Pascal 7.0     *)
(*                                                               *)
(*     and Turbo Pascal 1.5                                      *)
(*                                                               *)
(*     SFXMDTB.PAS : SpecialFX MDI window sample application     *)
(*                   with a toolbar & hints                      *)
(*     Uses modified SFXWnds Unit SFXWNDS2.PAS for font selection*)
{*****************************************************************}
(* Submitted by Bill Miller                                      *)
(*****************************************************************)

program SFXMDITB;
 
{$R SFXMDITB.RES}
{$M 16184, 16184}

uses WinTypes, WinProcs, WinDos, SFX200, ODMenu, Strings, SFXWnds2,
{$IFDEF Ver15}
WObjects, StdDlgs, StdWnds,
{$ELSE}
Objects, OWindows, ODialogs, OMemory, OStdDlgs, OStdWnds, UPrint, OPrinter,
CommDlg, Win31, ToolHelp;
{$ENDIF}

type
{ Filename string }
TFilename = array [0..255] of Char;

const
id_Toolbar         = 100;
id_Statusbar       = 200;
DskFile            = 'SFXMDI.DSK';

{Toolbar id's}
id_NewFile         = 200;
id_OpenFile        = 201;
id_FileSave        = 202;
id_PrinterSetup    = 204;
id_PageSetup       = 205;
id_Exit            = 206;
id_EditUndo        = 300;
id_EditCut         = 301;
id_EditCopy        = 302;
id_EditPaste       = 303;
id_EditFind        = 400;
id_EditReplace     = 401;
id_Font            = 402;
id_Enlarge         = 403;
id_Reduce          = 404;
id_TileChildren    = 500;
id_CascadeChildren = 501;
id_ArrangeIcons    = 502;
id_CloseTopChild   = 503;
id_NextChild       = 504;

{Menu id's}
cm_OpenFile        = 24332;
cm_ArrangeIcons    = 24335;
cm_FileSaveAs      = 24334;
cm_Next            = 24328;
cm_PrintSetup      = 101;
cm_Print           = 102;
cm_Font            = 4000;
cm_decrease        = 4002;
cm_increase        = 4001;
cm_Popup           = 5001;
cm_Top             = 5002;
cm_ExitWindow      = 99;
cm_Show            = 202;
cm_About           = 999;
cm_SaveState       = 103;
cm_RestoreState    = 104;
cm_TileChildren    = 24336;
cm_CascadeChildren = 24337;
cm_CloseAll        = 24338;

{About dialog constants}
dlg_about          = 'ABOUT';
dlg_register       = 'REGISTER';
ab_WinMode         = 101;
ab_FreeMem         = 102;
ab_ResPct          = 103;
ab_mathco          = 104;
ab_winver          = 105;
ab_dosver          = 106;
ab_register        = 24;

{Page setup dialog constants}
id_phlft           = 101;
id_phctr           = 102;
id_phrgt           = 103;
id_pflft           = 104;
id_pfctr           = 105;
id_pfrgt           = 106;
id_tmar            = 107;
id_lmar            = 108;
id_bmar            = 109;
id_nlines          = 111;

type

{ Declare TNewToolBar a TSFXToolbar descendant }
PNewToolBar = ^TNewToolBar;
TNewToolBar = object(TSFXToolBar)
procedure WMMouseMove (var Msg: TMessage); virtual wm_First + wm_MouseMove;
end;

{ Declare TStatusBar a TSFXToolbar descendant }
PStatusBar = ^TStatusBar;
TStatusBar = object(TSFXToolBar)
procedure WMMouseMove (var Msg: TMessage); virtual wm_First + wm_MouseMove;
end;

{ Declare TSFXMdiApp }
TSFXMDIApp = object(TApplication)
   procedure InitMainWindow; virtual;
   procedure InitInstance; virtual;
end;

{ Register Dialog Declarations }
PRegisterDlg = ^TRegisterDlg;
TRegisterDlg = object (TDialog)
   constructor Init (AParent: PWindowsObject; AnID: PChar);
   procedure   GetWindowClass (var WC: TWndClass); virtual;
   function    GetClassName: PChar; virtual;
   procedure   SetupWindow; virtual;
end;

{ Memory About Dialog Declarations }
PAbtDlg = ^TAbtDlg;
TAbtDlg = object (TDialog)
   constructor Init (AParent: PWindowsObject; AnID: PChar);
   procedure   GetWindowClass (var WC: TWndClass); virtual;
   function    GetClassName: PChar; virtual;
   procedure   SetupWindow; virtual;
   procedure   IDRegister (var Msg: TMessage); virtual id_First + ab_register;
end;

{Declare a page setup object}
PSetupDlg = ^TSetupDlg;
TSetupDlg = object(TDialog)
   constructor Init(AParent: PWindowsObject; AnID: PChar);
   procedure SetupWindow; virtual;
end;

{Declare a printing object}
PEditOut = ^TEditOut;
TEditOut = object(TEditPrintout)
   procedure PrintPage(Page: Word; var Rect: TRect; Flags: Word); virtual;
end;

{ Declare TFileEditor, a TFileWindow desendant }
  PFileEditor = ^TFileEditor;
  TFileEditor = object(TSFXFileWindow)
    LPixY      : word;
    MenuFont   : HFont;
    Color      : LongInt;
	  TextColor  : LongInt;
    constructor Init(AParent: PWindowsObject; AFileName: PChar);
    procedure SetupWindow; virtual;
    destructor Done; virtual;
    procedure GetWindowClass(var AWndClass: TWndClass); virtual;
    function  GetClassName: PChar; virtual;
    procedure MakeDefaultFont(var AFont: HFont);
    procedure Create3DMenus;
    procedure CMPrint(var Msg: TMessage); virtual;
    procedure WMMeasureItem (var Msg: TMessage); virtual wm_First + wm_MeasureItem;
	  procedure WMDrawItem (var Msg: TMessage); virtual wm_First + wm_DrawItem;
  end;

{ Declare TMDIFileWindow a TSFXMDIWindow descendant }
PMDIFileWindow = ^TMDIFileWindow;
TMDIFileWindow = object(TSFXMDIWindow)
   OldToolbarPos : Integer;
	 ToolbarPos    : Integer;
	 Toolbar       : PNewToolbar;
   Statusbar     : PStatusbar;
   MenuFont      : HFont;
   OldFont       : HFont;
   Color         : LongInt;
	 TextColor     : LongInt;
   NumPages      : integer;
   Menu          : HMenu;
	 SubMenu       : HMenu;
   constructor Init(ATitle: PChar; AMenu: HMenu);
   destructor Done; virtual;
   procedure GetWindowClass(var AWndClass: TWndClass); virtual;
   function  GetClassName: PChar; virtual;
   function  InitChild : PWindowsobject; virtual;
   procedure InitClientWindow; virtual;
   procedure SetupWindow; virtual;
   procedure Create3DMenus;
   procedure WMMeasureItem (var Msg: TMessage); virtual wm_First + wm_MeasureItem;
	 procedure WMDrawItem (var Msg: TMessage); virtual wm_First + wm_DrawItem;
	 procedure WMMenuChar (var Msg: TMessage); virtual wm_First + wm_MenuChar;
   procedure EnableCommand(Command: Word; EnableIt: Boolean);
   procedure UpdateStatusBar;
   procedure MakeDefaultFont(var AFont: HFont);
   procedure CMNewFile(var Msg: TMessage); virtual cm_First + cm_MDIFileNew;
   procedure CMOpenFile(var Msg: TMessage); virtual cm_First + cm_MDIFileOpen;
   procedure PrinterSetup(var Msg : TMessage);
   procedure PageSetup(var Msg : TMessage);
   procedure CMFont(var msg:Tmessage); virtual cm_First or cm_Font;
   procedure CMEnlarge(var Msg:TMessage); virtual;
   procedure CMReduce(var Msg:TMessage); virtual;
   procedure CMPopup (var Msg: TMessage); virtual cm_First + cm_Popup;
	 procedure CMTop (var Msg: TMessage); virtual cm_First + cm_Top;
   procedure CMShow (var Msg: TMessage); virtual cm_First + cm_Show;
   procedure CMExitWindow (var Msg: TMessage); virtual cm_First + cm_ExitWindow;
   procedure CMAbout (var Msg: TMessage); virtual cm_First + cm_About;
   procedure CMSaveState(var Msg: TMessage); virtual cm_First + cm_SaveState;
   procedure CMRestoreState(var Msg: TMessage); virtual cm_First + cm_RestoreState;
   procedure UpdateClientArea(Width, Height: Integer);
   procedure WMInitMenuPopup (var Msg: TMessage); virtual wm_First + wm_InitMenuPopup;
   procedure WMSize(var Msg : TMessage); virtual wm_First+wm_Size;
   procedure WMSysCommand (var Msg: TMessage); virtual wm_First+wm_SysCommand;
   procedure WMCommand (var Msg: TMessage); virtual wm_First + wm_Command;
   procedure CloseTopChild;
   procedure NextChild;
end;

const
  EditorCount: Integer = 0;

const
  RFileEditor: TStreamRec = (
    ObjType: 1000;
    VmtLink: Ofs(TypeOf(TFileEditor)^);
    Load:    @TFileEditor.Load;
    Store:   @TFileEditor.Store);

var
UseHints      : Boolean;
FileIsOpen    : Boolean;
FaceName      : array[0..79] of char;
PointSize     : array[0..79] of char;
NumberOfLines : array[0..79] of char;
NumberOfPages : array[0..79] of char;
DptSize       : integer;
NOL           : Integer;
MaxLineLength : word;
Font          : TLogFont;   { Logical font }
TheFont       : HFont;       {Font handle}
FileName      : array[0..79] of char;
Edit          : PFileEditor;
Printer       : PPrinter;    { Pointer to a TPrinter object }

{ Global Methods }
{-Convert a real number to a string}
function RealToStr (Dest : PChar; R : Real; Width : Byte; Places : ShortInt) : PChar;
var
   Stng : string;
begin  {RealToStr}
   Str (R:Width:Places, Stng);
   RealToStr := StrPCopy (Dest, Stng);
end; {RealToStr}

{-Convert a integer number to a nul terminated string}
function LongToStr (Dest : PChar; L : LongInt) : PChar;
var
   Stng : string;
begin {LongToStr}
   Str (L, Stng);
   LongToStr := StrPCopy (Dest, Stng);
end; {LongToStr}

procedure TNewToolbar.WMMouseMove (var Msg: TMessage);
var
	DC       : HDC;
	ChildWnd : HWnd;
	StatWnd  : HWnd;
	ChildID  : Integer;
	szTemp   : array[0..144] of Char;
	szText   : array[0..144] of Char;
begin
	(* To set the text in a top toolbar, bottom toolbar or status bar
	 * you need to retrieve the window handle of the toolbar's static control
	 * by specifying the offset MTB_WNDSTATIC in a call to GetWindowWord. The
	 * return value is the window handle of the static control.
	 *)
	if UseHints then
	begin
		if not PtInClient(HWindow, MakePoint(Msg.lParam)) then
			Exit;
		ChildWnd := ChildWindowFromPoint(HWindow, MakePoint(Msg.lParam));
		StatWnd := GetWindowWord(HWindow, mtb_WndStatic);
		GetWindowText(StatWnd, szTemp, sizeof(szTemp));
		ChildID := GetDlgCtrlID(ChildWnd);
		if ChildID = id_NewFile then
			StrCopy(szText, ' Create a new document')
		else
		if ChildID = id_OpenFile then
			StrCopy(szText, ' Open an existing document')
		else
		if ChildID = id_FileSave then
			StrCopy(szText, ' Save document')
		else
		if ChildID = id_PageSetup then
			StrCopy(szText, ' Print document')
    else
		if ChildID = id_EditUndo then
			StrCopy(szText, ' Undo last change')
    else
		if ChildID = id_EditCut  then
			StrCopy(szText, ' Cut selected text to clipboard')
    else
    if ChildID = id_EditCopy then
			StrCopy(szText, ' Copy selected text to clipboard')
    else
    if ChildID = id_EditPaste then
			StrCopy(szText, ' Paste clipboard text to document')
    else
     if ChildID = id_EditFind then
			StrCopy(szText, ' Find text...')
    else
    if ChildID = id_EditReplace then
			StrCopy(szText, ' Replace text...')
    else
    if ChildID = id_Font then
			StrCopy(szText, ' Select a font for the editor...')
    else
    if ChildID = id_Enlarge then
			StrCopy(szText, ' Increase font point size')
    else
    if ChildID = id_Reduce then
			StrCopy(szText, ' Decrease font point size')
    else
     if ChildID = id_Exit then
			StrCopy(szText, ' Edit SFXMDIEdit')
    else
			{ If the cursor is in the static control the text is cleared. }
			szText[0] := #0;
		if StrIComp(szText, szTemp) <> 0 then
			SetWindowText(StatWnd, szText);
	end;
end;

procedure TStatusbar.WMMouseMove (var Msg: TMessage);
var
	DC       : HDC;
	ChildWnd : HWnd;
	StatWnd  : HWnd;
	ChildID  : Integer;
	szTemp   : array[0..144] of Char;
	szText   : array[0..144] of Char;
begin
	if UseHints then
	begin
		if not PtInClient(HWindow, MakePoint(Msg.lParam)) then
			Exit;
		ChildWnd := ChildWindowFromPoint(HWindow, MakePoint(Msg.lParam));
		StatWnd := GetWindowWord(HWindow, mtb_WndStatic);
		GetWindowText(StatWnd, szTemp, sizeof(szTemp));
		ChildID := GetDlgCtrlID(ChildWnd);
    if ChildID = id_TileChildren then
			StrCopy(szText, ' Tile MDI windows')
    else
     if ChildID = id_CascadeChildren then
			StrCopy(szText, ' Cascade MDI windows')
    else
    if ChildID = id_NextChild then
			StrCopy(szText, ' Display next MDI window')
    else
     if ChildID = id_CloseTopChild then
			StrCopy(szText, ' Close active MDI window')
    else
    begin
      { If the cursor is in the static control the text is changed to show status text. }
	    StrCopy(szText, 'Font: ');
      StrCat(szText, FaceName);
      StrCat(szText, #9);
      StrCat(szText, 'Size: ');
      StrCat(szText, PointSize);
      StrCat(szText, #9);
      StrCat(szText, #9);
      StrCat(szText, #9);
      StrCat(szText, #9);
      StrCat(szText, #9);
      StrCat(szText, #9);
      StrCat(szText, #9);
      StrCat(szText, #9);
      StrCat(szText, #9);
      StrCat(szText, #9);
      StrCat(szText, #9);
      StrCat(szText, #9);
      StrCat(szText, 'Lines: ');
      StrCat(szText, NumberOfLines);
    end;
		if StrIComp(szText, szTemp) <> 0 then
    begin
      { Set inital statusbar text }
      StatWnd := GetWindowWord(HWindow, mtb_WndStatic);
      SetWindowText(StatWnd, szText);
    end;
	end;
end;

{---------------------} { TRegisterdlg's Methods } {---------------------}

constructor TRegisterDlg.Init;
begin {Init}
  inherited Init (AParent,AnID);
  {Set SFX dialog to steel attribute}
   Attr.Param := mws_Flat3DSteel;
end; {Init}

procedure TRegisterDlg.GetWindowClass(var WC: TWndClass);
begin {GetWindowClass}
  inherited GetWindowClass (WC);
end;  {GetWindowClass}

function TRegisterDlg.GetClassName: PChar;
begin {GetClassName}
  GetClassName := 'Register';
end; {GetClassName}

procedure TRegisterDlg.SetupWindow;
begin
 inherited SetupWindow;
  {Center the main window on the screen}
   CenterWindow (0, HWindow);
end;

{ ************ TAbtdlg's Methods ***************** }
constructor TAbtDlg.Init;
begin {Init}
  inherited Init (APArent,AnID);
  {Set SFX dialog to steel attribute}
   Attr.Param := mws_Flat3DSteel;
end; {Init}

procedure TAbtDlg.GetWindowClass(var WC: TWndClass);
begin {GetWindowClass}
  inherited GetWindowClass (WC);
end;  {GetWindowClass}

function TAbtDlg.GetClassName: PChar;
begin {GetClassName}
  GetClassName := 'BORDLG_ABT';
end; {GetClassName}

procedure TAbtDlg.SetupWindow;
var
  M           : TMemManInfo;
  H           : TSysHeapInfo;
  Temp        : array[0..40] of Char;
  PercentFree : Word;
  UserFree    : Word;
  len         : Word;
  Ver: Longint;
  ArgList: array[0..1] of word;
  WindowsVersion: Array[0..30] of Char;
  VersionDos: Array[0..30] of Char;
begin {SetupWindow}
  inherited SetupWindow;
  {Center the main window on the screen}
   CenterWindow (0, HWindow);
  if (GetWinFlags and wf_Enhanced) <> 0 then
    SendDlgItemMsg (ab_WinMode, wm_SetText, 0,
      LongInt (PChar('386 Enhanced Mode')))
  else
    SendDlgItemMsg (ab_WinMode, wm_SetText, 0,
      LongInt (PChar ('Standard Mode')));

  if WordBool(GetWinFlags and WF_80x87) then
    SendDlgItemMsg (ab_MathCo, wm_SetText, 0,
      LongInt (PChar('Present')))
  else
    SendDlgItemMsg (ab_MathCo, wm_SetText, 0,
      LongInt (PChar('None')));

    LongToStr (Temp, GetFreeSpace(0) div 1024); {K}
   {insert a comma}
    len := StrLen (temp);
    if len > 3 then
    begin
       Move(temp[len-3], temp[len-2], 5);
       temp[len-3] := ',';
    end;
  StrCat (Temp,' K bytes');
  SendDlgItemMSg (ab_FreeMem, wm_SetText, 0, LongInt(@TEMP));
  H.dwSize := SizeOf (TSysHeapInfo);
  SystemHeapInfo (@H);
  if H.wUserFreePercent < H.wGDIFreePercent then
    PercentFree := H.wUserFreePercent
  else
    PercentFree := H.wGDIFreePercent;
  Str (PercentFree,Temp);
  StrCat (Temp,' % free');
  SendDlgItemMsg (ab_ResPct, wm_SetText, 0, LongInt(@TEMP));

  Ver := GetVersion;
  ArgList[0] := Lo(LoWord(Ver));
  ArgList[1] := Hi(LoWord(Ver));
  wvSprintf(WindowsVersion, '%d.%d', ArgList);
  SendDlgItemMsg (ab_WinVer, wm_SetText, 0, LongInt(@WindowsVersion));

  Ver := DosVersion;
  ArgList[0] := Lo(Ver);
  ArgList[1] := Hi(Ver);
  wvsprintf(VersionDos, '%d.%d', ArgList);
  SendDlgItemMsg (ab_DOSVer, wm_SetText, 0, LongInt(@VersionDos));

end; {SetupWindow}

procedure TAbtDlg.IDRegister (var Msg: TMessage);
begin
  Application^.ExecDialog (New (PRegisterDlg, Init (@Self, PChar (dlg_Register))));
end;

{TSetupDlg Methods}
constructor TSetupDlg.Init;
begin {Init}
  inherited Init (AParent,AnID);
  {Set SFX dialog to steel attribute}
   Attr.Param := mws_SFXFrame;
end; {Init}

procedure TSetupDlg.SetupWindow;
begin {SetupWindow}
  inherited SetupWindow;
  {Center the main window on the screen}
   CenterWindow (0, HWindow);
end;

{- Print page (or pages) }
procedure TEditOut.PrintPage(Page: Word; var Rect: TRect; Flags: Word);
var
LineIndex, Len: Integer;
Buffer: PChar;
begin
  LineIndex := 0;
   NumLines := Editor^.GetNumLines;
   if (NumLines > 0) and PrnStart(FileName) then
   begin
      while LineIndex < NumLines do
      begin
         Len := Editor^.GetLineLength(LineIndex) + 1;
         GetMem(Buffer, Len);
         if Len > 1 then
            Editor^.GetLine(Buffer, Len, LineIndex)
            else
            Buffer^ := #0;
            PrnLine(Buffer);
            Inc(LineIndex);
            FreeMem(Buffer, Len);
         end;
         PrnStop;
      end;
end;

{************** TFileEditor's Methods *************}
type
TMenuState = (msEnable, msDisable);
procedure MenuItems(State: TMenuState);

	procedure ModifyCommand(Command: Word);
	var
		NewState: Word;
	begin
		NewState := mf_ByCommand;
		if State = msEnable then
			Inc(NewState, mf_Enabled)
		else
			Inc(NewState, mf_Disabled + mf_Grayed);
		EnableMenuItem(PWindow(Application^.MainWindow)^.Attr.Menu, Command, NewState);
	end;

begin
	if Application^.MainWindow^.HWindow = 0 then Exit;
	ModifyCommand(cm_FileSave);
  ModifyCommand(cm_FileSaveAs);
  ModifyCommand(cm_ArrangeIcons);
  ModifyCommand(cm_TileChildren);
  ModifyCommand(cm_CascadeChildren);
  ModifyCommand(cm_CloseChildren);
  ModifyCommand(cm_EditCut);
  ModifyCommand(cm_EditCopy);
  ModifyCommand(cm_EditPaste);
  ModifyCommand(cm_EditDelete);
  ModifyCommand(cm_EditClear);
  ModifyCommand(cm_EditUndo);
  ModifyCommand(cm_EditFind);
  ModifyCommand(cm_EditReplace);
  ModifyCommand(cm_EditFindNext);
end;

procedure IncEditors;
begin
	if EditorCount = 0 then
		MenuItems(msEnable);
  Inc(EditorCount);
end;

procedure DecEditors;
begin
  Dec(EditorCount);
	if EditorCount = 0 then
		MenuItems(msDisable);
end;

constructor TFileEditor.Init(AParent: PWindowsObject; AFileName: PChar);
begin
  TSFXFileWindow.Init(AParent, '', AFileName);
  Attr.Style := Attr.Style or MWS_SFXFRAME or MWS_SFXCAPTION;
  {Attr.Style := Attr.Style or MWS_3DFRAME or MWS_SFXCAPTION;}
  IncEditors;
  NOL := 0;
  NumberOfLines[0] := #0;
  Color := 0;
	TextColor := 0;
end;

procedure TFileEditor.SetUpWindow;
var
MyDc : hDC;
begin
 TSFXFileWindow.SetupWindow;
 MyDc := GetDC(hWindow);
 LPixY := GetDeviceCaps(MyDc,LOGPIXELSY);
 ReleaseDC(HWindow,MyDc);
 NOL := Editor^.GetNumLines;
 LongToStr(NumberOfLines,NOL);
 MakeDefaultFont(MenuFont);
 Create3DMenus;
end;

destructor TFileEditor.Done;
begin
  DeleteObject(MenuFont);
  DecEditors;
  TSFXFileWindow.Done;
end;

procedure TFileEditor.GetWindowClass(var AWndClass: TWndClass);
begin
  TSFXFileWindow.GetWindowClass(AWndClass);
  AWndClass.hIcon := LoadIcon(HInstance, 'FILEICON');
end;

function TFileEditor.GetClassName: PChar;
begin
  GetClassName := 'FileEditor';
end;

procedure TFileEditor.MakeDefaultFont(var AFont: HFont);
begin
  FillChar(Font, SizeOf(TLogFont), #0);
  with Font do
  begin
    lfHeight        := -13;
    lfWeight        := 100;    {Indicate a Bold attribute         }
    lfItalic        := 0;      {Non-zero value indicates italic   }
    lfUnderline     := 0;      {Non-zero value indicates underline}
    lfOutPrecision  := Out_Stroke_Precis;
    lfClipPrecision := Clip_Stroke_Precis;
    lfQuality       := Proof_Quality;
    lfPitchAndFamily:= Variable_Pitch;
    StrCopy(lfFaceName, 'Arial');
  end;
  MenuFont := CreateFontIndirect(Font);
end;

procedure TFileEditor.Create3DMenus;
begin
	(* Since the system menu rarely gets modified, Set3DSystemMenu can be used to
	 * automatically set up a basic ownerdraw system menu.
	 *)
	Set3DSystemMenu(HWindow, 'SFXMDIEditor');
end;

{print text in editor window}
procedure TFileEditor.CMPrint(var Msg: TMessage);
var
Printout: PEditOut; { TEditPrintout }
begin
  if Printer <> nil then
  begin
   { if IsNewFile then StrCopy(FileName, 'Untitled'); }
    Printout := New(PEditOut, Init(Editor, FileName));
    if Printout <> nil then
    begin
      Printout^.Banding := true;
      Printer^.Print(@Self, Printout);
      Dispose(Printout, Done);
    end;
  end;
end;

procedure TFileEditor.WMDrawItem (var Msg:tMessage);
begin
	(* Pass WMDrawItem onto DrawMenuItem. If you don't want the user to
	 * change fonts and highlight colors you can use the default zero
	 * values for Font, Color and TextColor.
	 *)
	if PDrawItemStruct(Msg.lParam)^.CtlType = ODT_MENU then
		DrawMenuItem(PDrawItemStruct(Msg.lParam), MenuFont, Color, TextColor);
end;

procedure TFileEditor.WMMeasureItem (var Msg: TMessage);
begin
	(* The same font handle passed to DrawMenuItem must be passed to MeasureMenuItem
	 *)
	if PMeasureItemStruct(Msg.lParam)^.CtlType = ODT_MENU then
		MeasureMenuItem(HWindow, PMeasureItemStruct(Msg.lParam), MenuFont);
end;

{************* TMDIFileWindow's Methods ***************}
constructor TMDIFileWindow.Init(ATitle: PChar; AMenu: HMenu);
begin
  TSFXMDIWindow.Init(ATitle, AMenu);
  {Attr.Style := Attr.Style or MWS_SFXFRAME or MWS_SFXCAPTION;}
	Attr.Style := Attr.Style or MWS_3DFRAME or MWS_SFXCAPTION;
  Toolbar := nil;
  Statusbar := nil;
	ToolbarPos := 0;
  FileIsOpen := false;
  Color := 0;
	TextColor := 0;
end;

destructor TMDIFileWindow.Done;
begin
	DeleteObject(TheFont);
  DeleteObject(MenuFont);
  DestroyMenu(Menu);
	TSFXMDIWindow.Done;
end;

{ You need to override the default MDIClient class "SFX3DMDIClient" with
with the "SFXMDIClient" class when you use the MWS_SFXFRAME style }

procedure TMDIFileWindow.GetWindowClass(var AWndClass: TWndClass);
begin
  TSFXMDIWindow.GetWindowClass(AWndClass);
  AWndClass.hIcon := LoadIcon(HInstance, 'TextEdit2');
end;

function TMDIFileWindow.GetClassName: PChar;
begin
  GetClassName := 'TextEditor';
end;

function TMDIFileWindow.InitChild : PWindowsObject;
begin
	Edit :=  New(PFileEditor, Init(@Self, ''));
end;

{ You need to override the default MDIClient class "SFX3DMDIClient" with
with the "SFXMDIClient" class when you use the MWS_SFXFRAME style }

procedure TMDIFileWindow.InitClientWindow;
begin
   ClientWnd := New(PSFXMDIClient, Init(@Self, True));
end;

procedure TMDIFileWindow.SetupWindow;
var
	Msg : TMessage;
  StatWnd : HWnd;
  szText : array[0..144] of Char;
begin
  TSFXMDIWindow.SetupWindow;
  Attr.X := 0;
  Attr.Y := 0;
  Attr.W := 600;
  Attr.H := 440;
  StrCopy(FileName, '-[untitled]');
  {Use status bar hints}
  UseHints := True;
  MenuItems(msDisable);
  (* Create a top aligned toolbar *)
  CMTop(Msg);
  (*Create a bottom aligned status bar *)
  if (Statusbar <> nil) and (Statusbar^.HWindow <> 0) then
		DestroyWindow(Statusbar^.HWindow);
	Statusbar := New(PStatusbar, Init(@Self, id_Statusbar, '?,500,501,504,503', 0, 0, True));
	Statusbar^.Attr.Style := Statusbar^.Attr.Style or mtb_Row1 or mtb_Column4 or
													 mtb_BitmapButton or mtb_Status or mtb_Flush;
	Statusbar^.SetFlags(WB_MDICHILD, FALSE);
	Application^.MakeWindow(Statusbar);
  { Set the status bar font to MS SansSerif}
  Statusbar^.SetFont(GetSFXObject(Fine_Font));
 { Make default font for editor}
  DptSize := 100;
  MakeDefaultFont(TheFont);
  { Make default font for menus}
  MakeDefaultFont(MenuFont);
  {Create the 3DMenus}
  Create3DMenus;
  {Center the mainwindow on the screen}
  CenterWindow(0, hWindow);
  { Update static control to show status text. }
	StrCopy(szText, 'Font: ');
  StrCat(szText, FaceName);
  StrCat(szText, #9);
  StrCat(szText, 'Size: ');
  StrCat(szText, PointSize);
  StrCat(szText, #9);
  StrCat(szText, #9);
  StrCat(szText, #9);
  StrCat(szText, #9);
  StrCat(szText, #9);
  StrCat(szText, #9);
  StrCat(szText, #9);
  StrCat(szText, #9);
  StrCat(szText, #9);
  StrCat(szText, #9);
  StrCat(szText, #9);
  StrCat(szText, #9);
  StrCat(szText, 'Lines: ');
  StrCat(szText, NumberOfLines);
  { Set inital statusbar text }
  StatWnd := GetWindowWord(StatusBar^.HWindow, mtb_WndStatic);
  SetWindowText(StatWnd, szText);
  Printer := New(PPrinter, Init);
end;

procedure TMDIFileWindow.Create3DMenus;
begin
	(* Since the system menu rarely gets modified, Set3DSystemMenu can be used to
	 * automatically set up a basic ownerdraw system menu.
	 *)
	Set3DSystemMenu(HWindow, 'SFXMDIEditor');

	{ Modify main menu to display ownerdraw items }
	Menu := GetSubMenu(Attr.Menu, 0);
	ModifyMenu(Menu, 0, MF_BYPOSITION or MF_OWNERDRAW, CM_MDIFileNew, '&New file');
	ModifyMenu(Menu, 1, MF_BYPOSITION or MF_OWNERDRAW, CM_MDIFileOpen, '&Open file...');
	ModifyMenu(Menu, 2, MF_BYPOSITION or MF_OWNERDRAW, CM_FileSave, '&Save file');
	ModifyMenu(Menu, 3, MF_BYPOSITION or MF_OWNERDRAW, CM_FileSaveAs, 'Save &As...');
  ModifyMenu(Menu, 5, MF_BYPOSITION or MF_OWNERDRAW, CM_PrintSetup, 'Printer &Setup...');
  ModifyMenu(Menu, 6, MF_BYPOSITION or MF_OWNERDRAW, CM_Print, '&Print...');
  ModifyMenu(Menu, 8, MF_BYPOSITION or MF_OWNERDRAW, CM_ExitWindow, '&Exit');
	Menu := GetSubMenu(Attr.Menu, 1);
	ModifyMenu(Menu, 0, MF_BYPOSITION or MF_OWNERDRAW, CM_EditUndo, '&Undo');
	ModifyMenu(Menu, 2, MF_BYPOSITION or MF_OWNERDRAW, CM_EditCut, '&Cut');
	ModifyMenu(Menu, 3, MF_BYPOSITION or MF_OWNERDRAW, CM_EditCopy, 'C&opy');
	ModifyMenu(Menu, 4, MF_BYPOSITION or MF_OWNERDRAW, CM_EditPaste, '&Paste');
  ModifyMenu(Menu, 5, MF_BYPOSITION or MF_OWNERDRAW, CM_EditDelete, '&Delete');
	ModifyMenu(Menu, 6, MF_BYPOSITION or MF_OWNERDRAW, CM_EditClear, 'Clear &All Ctl+Del');
	Menu := GetSubMenu(Attr.Menu, 2);
	ModifyMenu(Menu, 0, MF_BYPOSITION or MF_OWNERDRAW, CM_EditFind, '&Find');
	ModifyMenu(Menu, 1, MF_BYPOSITION or MF_OWNERDRAW, CM_EditReplace, 'Replace');
	ModifyMenu(Menu, 2, MF_BYPOSITION or MF_OWNERDRAW, CM_Next, 'Next');
	Menu := GetSubMenu(Attr.Menu, 3);
	ModifyMenu(Menu, 0, MF_BYPOSITION or MF_OWNERDRAW, CM_Font, '&Font');
	ModifyMenu(Menu, 1, MF_BYPOSITION or MF_OWNERDRAW, CM_Increase, '&Increase');
	ModifyMenu(Menu, 2, MF_BYPOSITION or MF_OWNERDRAW, CM_Decrease, 'Decease');
  Menu := GetSubMenu(Attr.Menu, 4);
	ModifyMenu(Menu, 0, MF_BYPOSITION or MF_OWNERDRAW, CM_Popup, '&Popup');
	ModifyMenu(Menu, 1, MF_BYPOSITION or MF_OWNERDRAW, CM_Top, '&Top');
  Menu := GetSubMenu(Attr.Menu, 5);
  ModifyMenu(Menu, 0, MF_BYPOSITION or MF_OWNERDRAW, CM_TileChildren, '&Tile');
	ModifyMenu(Menu, 1, MF_BYPOSITION or MF_OWNERDRAW, CM_CascadeChildren, '&Cascade');
	ModifyMenu(Menu, 2, MF_BYPOSITION or MF_OWNERDRAW, CM_ArrangeIcons, '&Arrange Icons');
  ModifyMenu(Menu, 3, MF_BYPOSITION or MF_OWNERDRAW, CM_CloseAll, 'CloseAll');
  ModifyMenu(Menu, 5, MF_BYPOSITION or MF_OWNERDRAW, CM_SaveState, 'Save State');
  ModifyMenu(Menu, 6, MF_BYPOSITION or MF_OWNERDRAW, CM_RestoreState, '&Restore State');
  ModifyMenu(Menu, 7, MF_BYPOSITION or MF_OWNERDRAW or MF_CHECKED or MF_STRING, 0, nil);

	Menu := GetSubMenu(Attr.Menu, 6);
	ModifyMenu(Menu, 0, MF_BYPOSITION or MF_OWNERDRAW, CM_ABOUT, '&About');
end;

procedure TMDIFileWindow.WMDrawItem (var Msg:tMessage);
begin
	(* Pass WMDrawItem onto DrawMenuItem. If you don't want the user to
	 * change fonts and highlight colors you can use the default zero
	 * values for Font, Color and TextColor.
	 *)
	if PDrawItemStruct(Msg.lParam)^.CtlType = ODT_MENU then
		DrawMenuItem(PDrawItemStruct(Msg.lParam), MenuFont, Color, TextColor);
end;

procedure TMDIFileWindow.WMMeasureItem (var Msg: TMessage);
begin
	(* The same font handle passed to DrawMenuItem must be passed to MeasureMenuItem
	 *)
	if PMeasureItemStruct(Msg.lParam)^.CtlType = ODT_MENU then
		MeasureMenuItem(HWindow, PMeasureItemStruct(Msg.lParam), MenuFont);
end;

procedure TMDIFileWindow.WMMenuChar (var Msg: TMessage);
begin
	(* A mnemonic is the undelined letter in the text of a menu item. When a menu
	 * is active the user can select a menu item by pressing the key that corresponds
	 * to the item's underlined letter. Ownerdraw menus don't process standard menu
	 * mnemonics so you must trap the WM_MENUCHAR message and process them yourself.
	 * A WM_MENUCHAR message is sent when a menu is active and the user presses a key.
	 * wParam is the key's ascii character, the LOWORD of lParam is the menu type,
	 * either MF_POPUP or MF_SYSMENU and the HIWORD of lParam is the handle of the
	 * menu. The return value must be a long integer specifying the menu item's zero
	 * based position in its LOWORD and '2' in its HIWORD.
	 *
	 * Since the system menu rarely gets modified, ProcessSystemChar can be used to
	 * automatically handle system menu mnemonics.
	 *)
	if Msg.lParamLo and mf_SysMenu <> 0 then
		Msg.Result := ProcessSystemChar(Msg.wParam)
	else
	if Msg.lParamHi = GetSubMenu(Attr.Menu, 0) then
	begin
		case Msg.wParam of
			65, 97  : Msg.Result := MakeLong(0, 2);
			66, 98  : Msg.Result := MakeLong(1, 2);
			67, 99  : Msg.Result := MakeLong(2, 2);
			68, 100 : Msg.Result := MakeLong(3, 2);
			69, 101 : Msg.Result := MakeLong(5, 2);
      70, 101 : Msg.Result := MakeLong(6, 2);
		end;
	end
	else
	if Msg.lParamHi = GetSubMenu(Attr.Menu, 1) then
	begin
		case Msg.wParam of
			65, 97  : Msg.Result := MakeLong(0, 2);
			66, 98  : Msg.Result := MakeLong(1, 2);
			83, 115 : Msg.Result := MakeLong(2, 2);
			68, 100  : Msg.Result := MakeLong(3, 2);
		end;
	end
	else
	if Msg.lParamHi = GetSubMenu(Attr.Menu, 2) then
	begin
		case Msg.wParam of
			65, 97  : Msg.Result := MakeLong(0, 2);
			66, 98  : Msg.Result := MakeLong(1, 2);
			67, 99 : Msg.Result := MakeLong(2, 2);
			83, 115 : Msg.Result := MakeLong(3, 2);
		end;
	end
	else
	if Msg.lParamHi = GetSubMenu(Attr.Menu, 3) then
	begin
		case Msg.wParam of
			70, 102 : Msg.Result := MakeLong(0, 2);
			67, 99  : Msg.Result := MakeLong(1, 2);
			84, 116 : Msg.Result := MakeLong(2, 2);
		end;
	end;
end;

{ Enable or disable menu items and toolbar icons at the request of
  child windows }
procedure TMDIFileWindow.EnableCommand(Command: Word; EnableIt: Boolean);
var
  StateFlags: Word;
begin
  if Attr.Menu <> 0 then
  begin
    if EnableIt then
      StateFlags := mf_ByCommand or mf_Enabled
    else
      StateFlags := mf_ByCommand or mf_Disabled or mf_Grayed;
    EnableMenuItem(Attr.Menu, Command, StateFlags);
  end;
end;

procedure TMDIFileWindow.UpdateStatusBar;
var
 szText      : array[0..144] of Char;
 StatBarWnd  : HWnd;
begin
 { Set inital statusbar text }
 StatBarWnd := GetWindowWord(Statusbar^.HWindow, mtb_WndStatic);
 StrCopy(szText, 'Font: ');
 StrCat(szText, FaceName);
 StrCat(szText, #9);
 StrCat(szText, 'Size: ');
 StrCat(szText, PointSize);
 StrCat(szText, #9);
 StrCat(szText, #9);
 StrCat(szText, #9);
 StrCat(szText, #9);
 StrCat(szText, #9);
 StrCat(szText, #9);
 StrCat(szText, #9);
 StrCat(szText, #9);
 StrCat(szText, #9);
 StrCat(szText, #9);
 StrCat(szText, #9);
 StrCat(szText, #9);
 StrCat(szText, 'Lines: ');
 StrCat(szText, NumberOfLines);
 SetWindowText(StatBarWnd, szText);
end;

procedure TMDIFileWindow.MakeDefaultFont(var AFont: HFont);
var
 szText      : array[0..144] of Char;
 StatBarWnd  : HWnd;
begin
  FillChar(Font, SizeOf(TLogFont), #0);
  with Font do
  begin
    lfHeight        := -13;
    lfWeight        := 100;    {Indicate a Bold attribute         }
    lfItalic        := 0;      {Non-zero value indicates italic   }
    lfUnderline     := 0;      {Non-zero value indicates underline}
    lfOutPrecision  := Out_Stroke_Precis;
    lfClipPrecision := Clip_Stroke_Precis;
    lfQuality       := Proof_Quality;
    lfPitchAndFamily:= Variable_Pitch;
    StrCopy(lfFaceName, 'Arial');
  end;
  TheFont := CreateFontIndirect(Font);
  MenuFont := CreateFontIndirect(Font);
  StrCopy(FaceName, 'Arial');
  Str((DptSize div 10):4, PointSize);
  StrCopy(PointSize, '10');
end;

procedure TMDIFileWindow.CMNewFile(var Msg: TMessage);
begin
  Edit := New(PFileEditor, Init(@Self, ''));
  Application^.MakeWindow(Edit);
end;

procedure TMDIFileWindow.CMOpenFile(var Msg: TMessage);
var
	Reply     : BOOL;
	Filters   : PChar;
	ofn       : TOpenFileName;
	szFile    : array[0..255] of Char;
	szCFilter : array[0..255] of Char;
  szText    : array[0..144] of Char;
  StatBarWnd: HWnd;
begin
	szFile[0] := #0;
	Filters := 'All Files (*.*)'#0'*.*'#0'Text (*.TXT)'#0'*.TXT'#0'Ini Files (*.INI)'#0'*.ini'#0;
	FillChar(ofn, SizeOf(TOpenFileName), #0);
	with ofn do
	begin
		lStructSize  := SizeOf(TOpenFileName);
		hwndOwner    := hWindow;
		hInstance    := GetSFXInstance;  { Returns the instance handle of SFX200.DLL }
		lpstrFile    := szFile;
		nMaxFile     := SizeOf(szFile);
		lpstrDefExt  := 'Txt';
		lpstrFilter  := Filters;
		nFilterIndex := 1;
		lpTemplateName := GetSFXTemplate('SFX3DDlg', dlg_OpenSave);
		Flags := ofn_FileMustExist or ofn_EnableTemplate;
		Flags := Flags or ofn_HideReadOnly;
		Reply := GetOpenFileName(ofn);
		(* At this point szFile will contain the selected filename
		 * including the entire path and nFilterIndex will contain the
		 * last selected filter index.
		 *)
		 if Reply then
     begin
        StrCopy(FileName, StrLower(OFN.lpstrFile));
        Edit := New(PFileEditor, Init(@Self, FileName));
        Application^.MakeWindow(Edit);
        FileIsOpen := True;
        UpdateStatusBar;
     end;
  end;
end;

procedure TMDIFileWindow.PrinterSetup(var Msg : TMessage);
var
PD: TPrintDlg;
begin  { _106 }
  FillChar(PD, Sizeof(PD), #0);
  with PD do
  begin
    lStructSize := Sizeof(TPrintDlg);
    hInstance   := GetSFXInstance;
    hWndOwner   := HWindow;
    lpSetupTemplateName := GetSFXTemplate('SFX3DDlg', DLG_PRINTSETUP);
    flags       := flags or pd_PrintSetup or pd_EnableSetupTemplate;
  end;
  if PrintDlg(PD) then
  begin
  {- ... Print using PD.hDC device context. }
    DeleteDC(PD.hDC);
    if PD.hDevMode <> 0 then
      GlobalFree(PD.hDevMode);
    if PD.hDevNames <> 0 then
      GlobalFree(PD.hDevNames);
  end;
end;

procedure TMDIFileWindow.PageSetup(var Msg : TMessage);
var
PD: TPrintDlg;
begin
  FillChar(PD, Sizeof(PD), #0);
  with PD do
  begin
    lStructSize := Sizeof(TPrintDlg);
    hInstance   := GetSFXInstance;
    hWndOwner   := HWindow;
    { Returns DC for printer }
		Flags := Flags or pd_ReturnDC or pd_AllPages or pd_Collate or pd_DisablePrintToFile or
						 pd_EnablePrintTemplate or pd_EnableSetupTemplate;

		nCopies := 1;             { Initial contents of the Copies edit control.}
		nFromPage := 1;           { Initial contents of the From edit control.}
    if NOL >0 then
		nToPage := NOL div 60     { Initial contents of the To edit control.}
    else
    nToPage := 0;
		nMinPage := 0;            { Lowest possible number in the From/To edits.}
    if NOL >0 then
		nMaxPage :=  NOL div 60   { Highest possible number in the From/To edits.}
    else
    nMaxPage := 0;
    lpPrintTemplateName := GetSFXTemplate('SFX3DDlg', DLG_PRINT);
  end;
  if PrintDlg(PD) then
  begin
  {- ... Print using PD.hDC device context. }
    DeleteDC(PD.hDC);
    if PD.hDevMode <> 0 then
      GlobalFree(PD.hDevMode);
    if PD.hDevNames <> 0 then
      GlobalFree(PD.hDevNames);
  end;
end;

procedure TMDIFileWindow.CMFont(var Msg: TMessage);
var
  OldCursor   : HCursor;   { cursor variable }
  NewCursor   : HCursor;   { cursor variable }
  CF          : TChooseFont;
  TempFont    : TLogFont;
  szText      : array[0..144] of Char;
  StatBarWnd  : HWnd;
begin
  if FileIsOpen then begin
  OldCursor := SetCursor(LoadCursor(0, idc_Arrow));
  NewCursor := SetCursor(LoadCursor(0, idc_Wait));
  FillChar(CF, Sizeof(CF), #0);
  TempFont := Font;  { Copy current font }
  with CF do
  begin
    lStructSize := SizeOf(TChooseFont);
    hInstance := GetSFXInstance;
    HWndOwner := HWindow;
    Flags := cf_InitToLogFontStruct or cf_Both or cf_Effects or cf_EnableTemplate;
    lpLogFont := @TempFont;
    lpTemplateName := GetSFXTemplate('SFXSteelDlg', DLG_FONT);
  end;
  if ChooseFont(CF) then with CF do
  begin
    Font := lpLogFont^;  { Use this font for text }
    if TheFont <> 0 then
    DeleteObject(TheFont);
    TheFont := CreateFontIndirect(Font);
    if Edit <> nil then
    SendMessage(Edit^.Editor^.hWindow, wm_SetFont, TheFont, 0);
    { Set statusbar text }
    StrCopy(FaceName, Font.lfFaceName);
    DptSize := CF.iPointSize;
    Str((DptSize div 10):4, PointSize);
    UpdateStatusBar;
  end;
end;
end;

procedure TMDIFileWindow.CMEnlarge(var MSg:TMessage);
var
szText      : array[0..144] of Char;
StatBarWnd  : HWnd;
begin
 if FileIsOpen then begin
 if DptSize<120 then Inc(DptSize,10) else Inc(DptSize,20);
 if DptSize>360 then DptSize := 360;
 Font.lfHeight := -1 * MulDiv(Edit^.LpixY,DptSize,720);
 Str((DptSize div 10):4, PointSize);
 UpdateStatusBar;
 {Create the larger font & set editor font}
 TheFont := CreateFontIndirect(Font);
 SendMessage(Edit^.Editor^.hWindow, wm_SetFont, TheFont, 0);
 end;
end;

procedure TMDIFileWindow.CMReduce(var Msg:TMessage);
var
szText      : array[0..144] of Char;
StatBarWnd  : HWnd;
begin
 if FileIsOpen then begin
 if DptSize<= 120 then Dec(DptSize,10) else Dec(DptSize,20);
 if DptSize<60 then DptSize := 60;
 Font.lfHeight := -1 * MulDiv(Edit^.LpixY,DptSize,720);
 Str((DptSize div 10):4, PointSize);
 UpdateStatusBar;
 {Create the smaller font & set editor font}
 TheFont := CreateFontIndirect(Font);
 SendMessage(Edit^.Editor^.hWindow, wm_SetFont, TheFont, 0);
 end;
end;

procedure TMDIFileWindow.CMPopup (var Msg: TMessage);
begin
	OldToolbarPos := ToolbarPos;
	if ToolbarPos <> cm_Popup then
	begin
		ToolbarPos := cm_Popup;
		if (Toolbar <> nil) and (Toolbar^.HWindow <> 0) then
			DestroyWindow(Toolbar^.HWindow);

		(* A popup toolbar is confined to the Windows' desktop and cannot be moved
		 * outside. The x value 'GetSystemMetrics(SM_CXSCREEN)' and the y value '0'
		 * ensure that the toolbar is positioned in the top-left corner of the
		 * desktop window.
		 *)
		Toolbar := New(PNewToolbar, Init(@Self, id_Toolbar,
    'Tools,200,201,202,205,300,301,302,303,400,401,402,403,404,500,501,504,503,206',
		GetSystemMetrics(SM_CXSCREEN), 0, FALSE));
		Toolbar^.Attr.Style := Toolbar^.Attr.Style or mtb_Row6 or mtb_Column3 or
													 mtb_BitmapButton or mtb_Float or mtb_3DFrame or ws_Caption;

		(* Set the WB_MDICHILD flag to FALSE
		 *)
		Toolbar^.SetFlags(WB_MDICHILD, FALSE);
		Application^.MakeWindow(Toolbar);
		UpdateClientArea(0, 0);
	end;
end;

procedure TMDIFileWindow.CMTop (var Msg: TMessage);
begin
	OldToolbarPos := ToolbarPos;
	if ToolbarPos <> cm_Top then
	begin
		(* An SFX Toolbar sizes itself according to the specified flags and the size
		 * of the first button's first bitmap, so cx and cy can be zero. x and y have
		 * no effect on an aligned toolbar and should be set to zero. To re position a
		 * toolbar you have to destroy the current one and create a new one. When you
		 * do, you will have to change the MTB_ROWXX, MTB_COLOUMNXX and the toolbar
		 * style flags: MTB_TOP, MTB_LEFT, MTB_RIGHT, MTB_BOTTOM, MTB_FLOAT and MTB_STATUS.
		 *)
		ToolbarPos := cm_Top;
		if (Toolbar <> nil) and (Toolbar^.HWindow <> 0) then
			DestroyWindow(Toolbar^.HWindow);
		Toolbar := New(PNewToolbar, Init(@Self, id_Toolbar, '?,200,201,202,205,300,301,302,303,400,401,402,403,404,206',
																		 0, 0, True));
		Toolbar^.Attr.Style := Toolbar^.Attr.Style or mtb_Row1 or mtb_Column14 or
													 mtb_BitmapButton or mtb_Top or mtb_Flush;
		Toolbar^.SetFlags(WB_MDICHILD, FALSE);
		Application^.MakeWindow(Toolbar);
    { Set the toolbar font to MS SansSerif}
    ToolBar^.SetFont(GetSFXObject(Fine_Font));
		UpdateClientArea(0, 0);
	end;
end;

procedure TMDIFileWindow.CMExitWindow (var Msg: TMessage);
begin
	CloseWindow;
end;

procedure TMDIFileWindow.CMShow (var Msg: TMessage);
begin
	ShowWindow(Toolbar^.HWindow, SW_SHOWNORMAL);
	ShowWindow(Statusbar^.HWindow, SW_SHOWNORMAL);
end;

procedure TMDIFileWindow.CMAbout (var Msg: TMessage);
begin
	Application^.ExecDialog(New(PAbtDlg, Init(@Self, 'About')));
end;

procedure TMDIFileWindow.CMSaveState(var Msg: TMessage);
var
	S : PStream;

	function FileDelete(Name: PChar): Integer; assembler;
	asm
		PUSH	DS
		LDS	DX,Name
		MOV	AH,41H
		INT	21H
		JC	@@1
		XOR	AX,AX
		@@1:	NEG	AX
		POP	DS
	end;

begin
	S := New(PBufStream, Init(DskFile, stCreate, 1024));
	PutChildren(S^);
	if S^.Status <> stOk then
	begin
    Dispose(S, Done);
    FileDelete(DskFile);
		MessageBox(HWindow, 'Unable to write desktop file.', 'Disk error', mb_IconExclamation);
  end
	else
		Dispose(S, Done);
end;

procedure TMDIFileWindow.CMRestoreState(var Msg: TMessage);
var
	S        : PStream;
	ErrorMsg : PChar;
begin
  ErrorMsg := nil;
  S := New(PBufStream, Init(DskFile, stOpenRead, 1024));
  if S^.Status <> stOk then
    ErrorMsg := 'Unable to open desktop file.'
  else
  begin
    CloseChildren;
		GetChildren(S^);
		if S^.Status <> stOk then
      ErrorMsg := 'Error reading desktop file.';
    if LowMemory then
    begin
      CloseChildren;
      ErrorMsg := 'Not enough memory to open file.'
    end
		else
			CreateChildren;
  end;
  if ErrorMsg <> nil then
		MessageBox(HWindow, ErrorMsg, 'Disk error', mb_IconExclamation);
end;

{procedure TMDIFileWindow.UpdateClientArea(Width, Height: Integer);
var
	X, Y, Z  : Integer;
	CRect : TRect;
begin
	if (ClientWnd <> nil) and (ClientWnd^.HWindow <> 0) then
	begin
		X := 0;
		Y := 0;
    Z := 2;
		if (Width = 0) and (Height = 0) then
		begin
			GetClientRect(HWindow, CRect);
			Width := CRect.Right - CRect.Left;
			Height := CRect.Bottom - CRect.Top;
		end;
    if ToolbarPos = cm_Popup then begin
      Y := 0; Z := 33;
      end;
		if ToolbarPos = cm_Top then begin
			Y := Toolbar^.Attr.H-1; Z := 33;
    end;
		MoveWindow(ClientWnd^.HWindow, X, Y, Width, (Height-Y-Z), TRUE);
	end;
end; }

procedure TMDIFileWindow.UpdateClientArea;
var
  X, Y, Z : Integer;
	CRect   : TRect;
begin
	if (ClientWnd <> nil) and (ClientWnd^.HWindow <> 0) then
	begin
		X := 0;
		Y := 0;
    Z := 2;
		if (Width = 0) and (Height = 0) then
		begin
			GetClientRect(HWindow, CRect);
			Width := CRect.Right - CRect.Left;
			Height := CRect.Bottom - CRect.Top;
		end;
    if ToolbarPos = cm_Popup then begin
      Y := 0; Z := 33;
      end;
		if ToolbarPos = cm_Top then begin
			Y := Toolbar^.Attr.H-1; Z := 33;
    end;
		MoveWindow(ClientWnd^.HWindow, X, Y, Width, (Height-Y-Z), TRUE);
	end;
end;

{ Allow special windows such as the Toolbar the opportunity to say how much room
 they need outside the MDI client area.  The default Windows processing for
 wm_Size always sets the MDI client area to fill the main window's client area,
 and it forces a repaint.  We don't want that, so we don't call the inherited
 wm_Size or the Windows default message processor. }
procedure TMDIFileWindow.wmSize(var Msg: TMessage);
var
  R: TRect;
begin
  GetWindowRect(HWindow, R);
  Attr.H := R.bottom - R.top;
  Attr.W := R.right - R.left;
  UpdateClientArea(Msg.lParamLo, Msg.lParamHi);
  ToolBar^.AlignToolbar;
  StatusBar^.AlignToolbar;
end;

procedure TMDIFileWindow.WMInitMenuPopup (var Msg: TMessage);
begin
	(* Use WM_INITPOPUPMENU to check/uncheck and enable/disable menu items
	 *)
	if (Msg.lParamHi = 0) and (Msg.lParamLo = 0) and (ToolbarPos <> OldToolbarPos) then
	begin
		CheckMenuItem(Msg.wParam, ToolbarPos, MF_CHECKED);
		CheckMenuItem(Msg.wParam, OldToolbarPos, MF_UNCHECKED);
	end
	else
	if (Msg.lParamHi = 0) and (Msg.lParamLo = 1) then
	begin
		if IsWindowVisible(Toolbar^.HWindow) then
			EnableMenuItem(Msg.wParam, cm_Show, MF_GRAYED)
		else
			EnableMenuItem(Msg.wParam, cm_Show, MF_ENABLED);
	end
	else
		TMDIFileWindow.DefWndProc(Msg);
end;

{-handle system menu commands}
procedure TMDIFileWindow.WMSysCommand (var Msg:TMessage);
begin  {WMSysCommand}
case Msg.Wparam of
         101: CMAbout (Msg);
         105: WinHelp(hWindow, 'IDLFMT.HLP', Help_Contents, 0);
    sc_Close: CloseWindow;  {Close the window}
		else DefWndProc (Msg);
  end;
end; {WMSysCommand}

procedure TMDIFileWindow.WMCommand(var Msg: TMessage);
var
Title : array[0..79] of char;
begin

	case Msg.Wparam of
		wm_MDIMaximize	               : SendMessage(ClientWnd^.HWindow, wm_MDIMaximize,0,0);
		wm_MDIRestore	           	     : SendMessage(ClientWnd^.HWindow, wm_MDIRestore,0,0);
		cm_MDIFileNew,id_NewFile          : begin
                                        CMNewFile(Msg);
                                        UpdateStatusBar;
                                     end;
		cm_MDIFileOpen,id_OpenFile        : begin
                                        CMOpenFile(Msg);
                                        UpdateStatusBar;
                                     end;
    cm_FileSave, id_FileSave       : begin
                                        Edit^.CMFileSave(Msg);
                                        UpdateStatusBar;
                                     end;
    cm_FileSaveAs                  : begin
                                        Edit^.CMFileSaveAs(Msg);
                                        UpdateStatusBar;
                                     end;
		cm_PrintSetup,id_PrinterSetup  : PrinterSetup(Msg);
		cm_Print,id_PageSetup      	   : Edit^.CMPrint(Msg);
		cm_ExitWindow,24340,id_Exit  	 : inherited CloseWindow;
    cm_EditUndo, id_EditUndo       : begin
                                        Edit^.Editor^.CMEditUndo(Msg);
                                        UpdateStatusBar;
                                     end;
    cm_EditCut, id_EditCut         : begin
                                        Edit^.Editor^.CMEditCut(Msg);
                                        UpdateStatusBar;
                                     end;
    cm_EditCopy, id_EditCopy       : Edit^.Editor^.CMEditCopy(Msg);
    cm_EditPaste, id_EditPaste     : begin
                                        Edit^.Editor^.CMEditPaste(Msg);
                                        UpdateStatusBar;
                                     end;
    cm_EditFind, id_EditFind       : Edit^.CMEditFind(Msg);
    cm_EditReplace, id_EditReplace : begin
                                        Edit^.CMEditReplace(Msg);
                                        UpdateStatusBar;
                                     end;
    cm_EditFindNext                : Edit^.CMEditFindNext(Msg);
    cm_Font,id_Font                : CMFont(Msg);
    cm_increase,id_Enlarge         : CMEnlarge(Msg);
    cm_decrease ,id_Reduce         : CMReduce(Msg);
		cm_TileChildren,id_TileChildren: TileChildren;
		cm_CascadeChildren,id_CascadeChildren : CascadeChildren;
		cm_ArrangeIcons,id_ArrangeIcons: ArrangeIcons;
		id_CloseTopChild 						   : begin
                                        CloseTopChild;
                                     end;
		id_NextChild	                 : begin
                                        NextChild;
                                        UpdateStatusBar;
                                     end;
	else
		TSFXMDIWindow.WMCommand(Msg);
	end;
end;

procedure TMDIFileWindow.CloseTopChild;
{-Close topmost child}
var
HW : hWnd;
begin
   HW := hWnd(SendMessage(ClientWnd^.hWindow, wm_MDIGetActive, 0, 0));
   if HW <> 0 then
      SendMessage(HW, wm_Close, 0, 0);
end;

procedure TMDIFileWindow.NextChild;
{-Switch to next child}
begin
   SendMessage(ClientWnd^.hWindow, wm_MDINext, 0, 0);
   UpdateStatusBar;
end;

{---------------------} { TSFXMDIApp's Methods }  {-----------------------}

procedure TSFXMDIApp.InitMainWindow;
begin
	MainWindow := New(PMDIFileWindow, Init('SpecialFX MDI Editor',
										LoadMenu(HInstance, 'Commands')));
  PMDIFileWindow(MainWindow)^.ChildMenuPos := 5;
end;

procedure TSFXMDIApp.InitInstance;
begin
  TApplication.InitInstance;
  if Status = 0 then
  begin
    HAccTable := LoadAccelerators(HInstance, 'Commands');
    if HAccTable = 0 then
      Status := em_InvalidWindow;
  end;
end;

var
App : TSFXMDIApp;
begin
App.Init('MDIFileApp');
App.Run;
App.Done;
end.
