unit Splash;

{============================================================================}
{                         Origional Splash Source                            }
{                                     By                                     }
{                                Lou Grinzo                                  }
{                                 May 1994                                   }
{                           Windows Tech Journal                             }
{                                 pp 46-50                                   }
{============================================================================}
{                     !!!! This is a modified unit !!!!                      }
{----------------------------------------------------------------------------}
{ The modifications (remarked) include code to center dialogs on the screen  }
{ and on windows and to detect left mouse button presses to end the dialog   }
{ Requires the Objectmate libary which is avaiable as shareware in the       }
{ Borland Pascal Forum on Compuserve.                                        }
{============================================================================}

interface
uses
   WinTypes,
   WinProcs,
   OWindows,
   ODialogs,
   SFX200;  {Objectmate interface libary}

procedure DoSplash(dlg_id, bmp, dlg_sec: word);

procedure DoAniSplash(dlg_id,bmp_id,dlg_sec,icon_x,icon_y,
      start_icon,end_icon,icon_msec: word);

procedure StartModelessSplash(dlg_id, bmp_id: word);
procedure EndModelessSplash;

implementation

const
   sp: PWindowsObject = nil;
   dlg_timer   = 100;
   icon_timer  = 101;

type
   PSplash = ^TSplash;
   TSplash = object(TDialog)
      dlg_seconds_left: word;
      bmp: word;

      constructor Init(AParent: PWindowsObject; dlg_id, Abmp_id, dlg_sec: word);
      destructor  Done; virtual;
      procedure   SetupWindow; virtual;
      { -added method to detect left mouse button presses }
      procedure   WMLButtonDown(var Msg: TMessage); virtual wm_First + wm_LButtonDown;
      procedure   WMPaint(var Msg: TMessage); virtual wm_First + wm_Paint;
      procedure   WMTimer(var Msg: TMessage); virtual wm_First + wm_Timer;
   end;

   PAniSplash = ^TAniSplash;
   TAniSplash = object(TDialog)
      dlg_seconds_left: word;
      icon_x, icon_y: word;
      start_icon, end_icon, next_icon, icon_msec: word;
      bmp: word;

      constructor Init(AParent: PWindowsObject; dlg_id, Abmp_id,
         dlg_sec, Aicon_x, Aicon_y, Astart_icon, Aend_icon,
         Aicon_msec: word);

      procedure   SetupWindow; virtual;
      { -added method to detect left mouse button presses }
      procedure   WMLButtonDown(var Msg: TMessage); virtual wm_First + wm_LButtonDown;
      procedure   WMPaint(var Msg: TMessage); virtual wm_First + wm_Paint;
      procedure   WMTimer(var Msg: TMessage); virtual wm_First + wm_Timer;
   end;

procedure DoSplash(dlg_id, bmp, dlg_sec: word);

begin
   Application^.ExecDialog(New(PSplash,
      Init(Application^.MainWindow,
      dlg_id,bmp,dlg_sec)));
end;

procedure DoAniSplash(dlg_id,bmp_id,dlg_sec,icon_x,icon_y,
      start_icon,end_icon,icon_msec: word);

begin
   Application^.ExecDialog(New(PAniSplash,
      Init(Application^.MainWindow,
      dlg_id,bmp_id,dlg_sec,icon_x,
      icon_y,start_icon,end_icon,icon_msec)));
end;

procedure PaintMe(HWindow: THandle; bmp: integer);

var
   PaintStruct: TPaintStruct;
   dc, mem_dc: HDC;
   oldbitmap, newbitmap: HBitmap;
   BmpInfo: TBitmap;

begin
   if bmp > 0 then
      begin
         newbitmap := LoadBitmap(HInstance,PChar(bmp));

         dc := BeginPaint(HWindow,PaintStruct);

         mem_dc := CreateCompatibleDC(dc);
         oldbitmap := SelectObject(mem_dc,newbitmap);
         GetObject(newbitmap,SizeOf(TBitmap),@BmpInfo);

         BitBlt(dc,0,0,BmpInfo.bmWidth,BmpInfo.bmHeight,
            mem_dc,0,0,srcCopy);

         DeleteObject(SelectObject(mem_dc,oldbitmap));
         DeleteDC(mem_dc);
         EndPaint(HWindow,PaintStruct);
      end;
end;

procedure StartModelessSplash(dlg_id, bmp_id: word);

begin
   if sp = nil then
      begin
         sp := New(PSplash,Init(Application^.MainWindow,
            dlg_id,bmp_id,0));
         sp^.EnableAutoCreate;
         Application^.MakeWindow(sp);
         ShowWindow(sp^.HWindow,sw_Normal);
         UpdateWindow(sp^.HWindow);
      end;
end;

procedure EndModelessSplash;

begin
   if sp <> nil then
      begin
         sp^.CloseWindow;
         sp := nil;
      end;
end;

constructor TSplash.Init(AParent: PWindowsObject;
   dlg_id, Abmp_id, dlg_sec: word);

begin
   TDialog.Init(AParent,PChar(dlg_id));

   dlg_seconds_left := dlg_sec;
   bmp              := Abmp_id;
end;

destructor TSplash.Done;

begin
   KillTimer(HWindow,dlg_timer);
   TDialog.Done;
end;

procedure TSplash.SetupWindow;

begin
   TDialog.SetupWindow;
   { - added method to center the splash window on the screen - from Objectmate libary }
   CenterWindow(0, HWindow);
   SetTimer(HWindow,dlg_timer,1000,nil);
end;

procedure TSplash.WMLbuttonDown(var Msg: TMessage);
begin
   EndDlg(0);
end;

procedure TSplash.WMPaint(var Msg: TMessage);

begin
   PaintMe(HWindow,bmp);
end;

procedure TSplash.WMTimer(var Msg: TMessage);

begin
   Dec(dlg_seconds_left);

   if dlg_seconds_left = 0 then
      EndDlg(0);
end;

constructor TAniSplash.Init(AParent: PWindowsObject; dlg_id,
   Abmp_id, dlg_sec, Aicon_x, Aicon_y, Astart_icon,
   Aend_icon, Aicon_msec: word);

begin
   TDialog.Init(AParent,PChar(dlg_id));

   dlg_seconds_left := dlg_sec;
   icon_x           := Aicon_x;
   icon_y           := Aicon_y;
   bmp              := Abmp_id;
   next_icon        := Astart_icon;
   start_icon       := Astart_icon;
   end_icon         := Aend_icon;
   icon_msec        := Aicon_msec;
end;

procedure TAniSplash.SetupWindow;

begin
   TDialog.SetupWindow;
   { -added methhod to center the splash window on the screen - - from Objectmate libary }
   CenterWindow(0, HWindow);
   SetTimer(HWindow,dlg_timer,1000,nil);
   SetTimer(HWindow,icon_timer,icon_msec,nil);
end;

{ -added methhod to notify main window of request to quit application }
procedure TAniSplash.WMLbuttonDown(var Msg: TMessage);
begin
   dlg_seconds_left := 1;
   {EndDlg(hwindow);} {modified to prevent GPF's}
end;

procedure TAniSplash.WMPaint(var Msg: TMessage);

begin
   PaintMe(HWindow,bmp);
end;

procedure TAniSplash.WMTimer(var Msg: TMessage);

var
   dc: HDC;
   h_icon: HIcon;

begin
   if Msg.wParam = dlg_timer then
      begin
         Dec(dlg_seconds_left);
         if dlg_seconds_left = 0 then
            EndDlg(hWindow); {modified to prevent GPF's}
      end
   else
      begin
         h_icon := LoadIcon(HInstance,PChar(next_icon));
         dc := GetDC(HWindow);
         SetMapMode(dc,MM_TEXT);
         DrawIcon(dc,icon_x,icon_y,h_icon);
         ReleaseDC(HWindow,dc);
         DestroyIcon(h_icon);
         Inc(next_icon);
         if next_icon > end_icon then
            next_icon := start_icon;
      end;
end;

end.