program TestComm;

Uses WinDOS, WinCRT, WinProcs, WinTypes, Strings, Comm;

var
  CommPort : PCommPort;
  strIn : String;
  lngBytesRead : LongInt;

  procedure ShowState;
  var
    Ch : Char;
  begin
    WriteLn('Com ID:     ', CommPort^.intComID);
    WriteLn('Baud:       ', CommPort^.Baud);
    WriteLn('Parity:     ', CommPort^.Parity);
    WriteLn('Data Bits:  ', CommPort^.DataBits);
    WriteLn('Stop Bits:  ', CommPort^.StopBits);
    WriteLn('XOnChar:    ', CommPort^.XOnChar);
    WriteLn('XOffChar:   ', CommPort^.XOffChar);
    WriteLn('XOnLim:     ', CommPort^.XonLim);
    WriteLn('XOffLim:    ', CommPort^.XoffLim);
    WriteLn('PeChar:     ', CommPort^.PeChar);
    WriteLn('EofChar:    ', CommPort^.EofChar);
    WriteLn;
    If CommPort^.LastError <> 0 Then
       WriteLn('ERROR:  ', CommPort^.LastError, '  ', strCommError);
    Write('Press any key to continue....');
    Ch := ReadKey;
    WriteLn;
    WriteLn('--------------------------------------------------------------');
  end;


var
  I : integer;
  pErr : Array[0..32] Of Char;
begin
  For I := 1 to 4 DO
      CloseComm(I);
  CommPort := New(PCommPort, Init(1, 512, 512));
  If CommPort^.intComID >= 0 Then
  With CommPort^ Do
  Begin
    SetBaudRate(1200);
    SetParity(Even);
    SetDataBits(8);
    SetStopBits(Stop1);
    ShowState;

    SetBaudRate(2400);
    SetParity(Mark);
    SetDataBits(7);
    SetStopBits(Stop2);
    SetEOFChar('A');
    SetXOnChar('Z');
    SetXOffChar('X');
    SetXOnLim(100);
    SetXOffLim(500);
    SetParityErrChar('Q');
    ShowState;
  End
  Else
  Begin
    StrPCopy(pErr, OpenCommError(CommPort^.intComID));
    MessageBox(0, pErr,'Comm Port Error', MB_ICONSTOP);
  End;
  CommPort^.Done;
  DoneWinCRT;
End.

