Unit TimerWin;
{ -------------------------- Revision History -----------------------------
  Timer-controlled window; simply call TimedWindow with time delay and one
  or two string-type messages. Test program in tstimwin.pas
  ----------------------------------------------------------------------- }

interface

uses BWCC, OWindows, ODialogs, Strings, WinTypes, WinProcs;

procedure TimedWindow( Aparent : PWindowsObject; msg1, msg2 : string;
  DelaySecs : real );

implementation

type
  PTimerWindow = ^TTimerWindow;
  TTimerWindow = Object( TWindow )
    Htimer : word;
    DelaySecs : real;
    Schreiben1,
    Schreiben2 : Pchar;
    Constructor Init( aParent: PWindowsObject; msg1, msg2 : string; DlySecs : real );
    Destructor Done; virtual;
    Procedure SetupWindow; virtual;
    Procedure WMTimer( Var msg: TMessage );
      virtual wm_first+wm_timer;
    Procedure WMUser( Var msg: TMessage );
      virtual wm_first+wm_user;
  End;


Constructor TTimerWindow.Init;
Begin
  inherited Init( nil, '' );
  Attr.Style := WS_POPUP and not WS_VISIBLE;
  GetMem( Schreiben1, length( msg1 ) + 1 );
  StrPcopy( Schreiben1, msg1 );
  if msg2 = '' then msg2 := 'E R O I C A';
  GetMem( Schreiben2, length( msg2 ) + 1 );
  StrPcopy( Schreiben2, msg2 );
  DelaySecs := DlySecs;
End;


Destructor TTimerWindow.Done;
Begin
  If HTimer <> 0 Then
    KillTimer( HWindow, 100 );
  inherited Done;
End;


Procedure TTimerWindow.SetupWindow;
begin
  inherited SetupWindow;
  PostMessage( HWindow, WM_USER, 0, 0 );
end;


Procedure TTimerWindow.WMTimer( Var msg: TMessage );

var hMsgDlg : Thandle;
    owner, temp   : Hwnd;

Begin
  { kill timer so we don't accumulate further timer messages while working }
  KillTimer( HWindow, 100 );
  HTimer := 0;
  { find topmost window owning this one }
  owner  := HWindow;
  temp   := HWindow;
  While temp <> 0 Do Begin
    { we just walk the window chain owner-wards until we find the
      main window and use that for GetLastActivePopup. }
    temp := GetWindow( owner, GW_OWNER );
    IF temp <> 0 Then
      owner := temp;
  End;
  { find and close the message box }
  hMsgDlg := GetLastActivePopup( owner );
  If (hMsgDlg <> Hwindow) and (hMsgDlg <> owner ) and
     IsWindow( hMsgDlg ) Then
    EndDialog( hMsgDlg, ID_CANCEL );
  { R.I.P. }
  CloseWindow;
End;    { WMTimer }


Procedure TTimerWindow.WMUser;
begin
  HTimer := SetTimer( HWindow, 100, round( 1000 * DelaySecs ), nil );
  if Htimer <> 0 then
    MessageBox( HWindow, Schreiben1, Schreiben2, MB_OK );
  { end if }
end;


procedure TimedWindow;

var PTW : PTimerWindow;

begin
  PTW := New( PTimerWindow, init( Aparent, msg1, msg2, DelaySecs ));
  Application^.MakeWindow( PTW );
end;


end.

